CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:CSEG,ES:CSEG,DS:CSEG
        org 100h
start:
jmp main
bios   db 8000h dup(0)
bseg   equ 0c800h
main proc near
        lea     si,himess
        call    tty
; get the length of the c800 bios
        mov     ax,0c800h
        mov     ds,ax
        cmp     word ptr ds:[0],0AA55h
        je      ok_bios
bad_bios:
        jmp     bad_end
ok_bios:
        mov     dh,byte ptr ds:[2]
        mov     dl,0
        shl     dx,1
        mov     bp,dx    ; length of bios area
        cmp     dx,0
        jle     bad_bios
; move the bios into the bios area
        mov     ax,cs
        add     ax,6
        mov     es,ax
        mov     dx,ax ; dx has the moved seg
        mov     si,0
        mov     di,0
        mov     cx,bp
        cld
rep     movsb
; now scan for c800h in the interrupt area and replace with
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        mov     ax,0
        mov     es,ax
        mov     di,2
        mov     cx,128
        cli
bloop:
        cmp     word ptr es:[di],0c800h
        jne     no_f
        push    es
        pop     es
        mov     word ptr es:[di],dx
        inc     ax
no_f:
        add     di,4
        loop    bloop
        sti
; check out dos for similar occurrences
        mov     di,0b0h
        push    ax
        mov     ax,70h
        mov     es,ax
        pop     ax
        mov     cx,8
dloop:
        cmp     word ptr es:[di],0c800h
        jne     no_f1
        mov     word ptr es:[di],dx
        inc     ax
        inc     di
no_f1:
        inc     di
        loop    dloop
d_end:
        cmp     ax,0
        je      bad_end1
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        mov     ax,bp
        lea     di,mdec+4
        mov     cx,5
mloop:
        push    cx
        mov     dx,0
        mov     cx,10
        div     cx
        or      dl,30h
        mov     es:[di],dl
        dec    di
        pop    cx
        loop   mloop
        lea    si,mdec
        mov    cx,4
zloop:
        cmp    byte ptr ds:[si],'0'
        jne    no_lead
        mov    byte ptr ds:[si],0ffh
        loop   zloop
no_lead:
        lea     si,imess
        call    tty
; exit resident
; set up length of data
        mov    dx,bp
        add    dx,60h
        int    27h
bad_end1:
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        lea     si,xmess
        jmp   no_mess
bad_end:
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        lea     si,emess
no_mess:
        call    tty
        int     20h
tty:
       cld
       lodsb
       cmp  al,0
       je   done
       cmp  al,0ffh
       je   tty
       mov  ah,14
       int  10h
       jmp  tty
done:
       ret
main    ENDP
himess db 13,10,'MAP_HD, Hard Disk Bios Mover',13,10
       db 'Copyright 1988 by Keith P. Graham',13,10,0
imess  db 'Found BIOS at '
       db ' C800:0 and moved '
mdec   db '00000 bytes to low memory',13,10,10,0
emess  db 7,'C800 Bios signature not found, Install aborted',13,10,0
xmess  db 7,'Bios found, but no interrupt references were discovered',13,10,0
CSEG    ENDS
        END   start
