; gwind is the EXE version of generic windowing
;
;   call sequence is si points to a menu
;     di points to save area
;  menu structure is:
;    db height
;    db width
;    db x loc
;    db y loc
;    db color
;    db lines of data
;    db 0
;
dseg segment para public 'DATA'
; window data
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
;
;save    dw   24*72 dup(0)   ;window buffer
;menu    db   16  ;height
;     db   40   ;width
;     db   20   ;x location
;     db   2     ;y location
;     db   17h  ; color
;; menu text
;     db   "  This is an example of int 24h",13,10
;     db   '       TANSTAAFL'
;     db   0  ; screens end with a zero
h       db  0
w       db  0
he      db  0
we      db  0
x       db  0
xe      db  0
y       db  0
ye      db  0
color   db  0
hide    dw  0
savesi  dw  0
savedi  dw  0
cursor  dw  0
t       dw  0
dseg    ends
;
;
cseg    segment para public 'CODE'
assume  cs:cseg,ds:dseg,es:dseg
do_window  proc near
public do_window
;
; this puts a window to the screen
       call   save_si
       call   save_cursor
       call   save_window
       call   put_mess
       call   hide_cursor
       ret
undo_window:
public undo_window
; this retores from a save,
; si is window, di is save area
       call    save_si
       call    restore_window
       call    restore_cursor
       ret
save_si:
;
       mov    savesi,si
       mov    savedi,di
       cld
       lodsb
      mov     h,al
      dec     al
      dec     al
      mov     he,al
       lodsb
      mov     w,al
      dec     al
      dec     al
      mov     we,al
       lodsb
      mov     x,al
       dec al
       add al,w
      mov     xe,al
       lodsb
      mov     y,al
       dec al
       add al,h
      mov     xe,al
       lodsb
      mov     color,al
      mov     t,si
      ret
put_mess:
; puts a message to the screen
       cld
       mov    si,t
       mov    dh,y
       mov    dl,x
       inc    dh
       inc    dl
       mov    cx,0     ; cl is column
mloop0:
       push   cx
       push   dx
mloop1:
       push   cx
       push   dx
       cmp    ch,he
       jge    end_put_mess
       lodsb
       cmp    al,0
       je     end_put_mess
       cmp    al,10
       je     ignore_char
       cmp    al,13
       je     new_line
       cmp    cl,we
       jge    ignore_char
; got the character put it on the screen
; locate the cursor
       push   ax
       mov    ah,2
       mov    bx,0
       int    10h
       pop    ax
       mov    ah,10
       mov    cx,1
       int    10h
       pop    dx
       pop    cx
       inc    dl
       inc    cl
       jmp    mloop1
new_line:
       pop    dx
       pop    cx
       pop    dx
       pop    cx
       inc    dh
       inc    ch
       jmp    mloop0
ignore_char:
       pop    dx
       pop    cx
       jmp    mloop1
end_put_mess:
       pop    dx
       pop    cx
       pop    dx
       pop    cx
       ret
restore_window:
; puts the old window back
;setup cursor at x,y
       mov    dh,y
       mov    dl,x
; set up save place
       mov    si,savedi
       cld
; the current cursor position is in dx
       mov    cl,h
       mov   ch,0
rloop1:
       push   cx
       push   dx
       mov    cl,w
       mov   ch,0
rloop2:
       push   cx
       push   dx
; locate
       mov    ah,2
       mov    bx,0
       int    10h
       lodsw
; put stuff
       mov    bl,ah
       mov    ah,9
       mov    bh,0
       mov    cx,1
       int    10h
       pop    dx
       pop    cx
       inc    dl
       loop   rloop2
       pop    dx
       pop    cx
       inc    dh
       loop   rloop1
       ret
restore_cursor:
; restore cursor
       mov     dx,cursor
       mov     ah,2
       mov     bx,0
       int     10h
save_cursor:
; get and save current x,y position
       mov   ah,3
       mov   bx,0
       int   10h
       mov   cursor,dx
       ret
save_window:
;setup cursor at x,y
       mov    dh,y
       mov    dl,x
; set up save place
       mov    di,savedi
       cld
; the current cursor position is in dx
       mov    cl,h
       mov    ch,0
wloop1:
       push   cx
       push   dx
       mov    cl,w
       mov   ch,0
wloop2:
       push   cx
       push   dx
; locate
       mov    ah,2
       mov    bx,0
       int    10h
; get stuff
       mov    ah,8
       mov    bx,0
       int    10h
; ax has the attrib and byte
       stosw
; find out what to put in al
       push   dx
       mov    al,20h
       cmp    dh,y  ; row
       je     top_row
       inc    dh
       sub    dh,h
       cmp    dh,y
       je     bot_row
       cmp    dl,x
       je     left_col
       inc    dl
       sub    dl,w
       cmp    dl,x
       je     right_col
       jmp    end_loop1
left_col:
right_col:
       mov    al,vert
       jmp    end_loop1
bot_row:
       mov    al,horiz
       cmp    dl,x
       je     bot_left
       inc    dl
       sub    dl,w
       cmp    dl,x
       je     bot_right
       jmp    end_loop1
bot_right:
       mov    al,loright
       jmp    end_loop1
bot_left:
       mov    al,loleft
       jmp    end_loop1
top_row:
       mov    al,horiz
       cmp    dl,x
       je     top_left
       inc    dl
       sub    dl,w
       cmp    dl,x
       je     top_right
       jmp    end_loop1
top_right:
       mov    al,upright
       jmp    end_loop1
top_left:
       mov    al,upleft
;       jmp    end_loop1
end_loop1:
       pop    dx
; place the correct character and attribute at the position
       mov    ah,9
       mov    bl,color
       mov    cx,1
       mov    bh,0
       int    10h
       pop    dx
       pop    cx
       inc    dl
       loop   jmp_wloop2
       jmp    by_wloop2
jmp_wloop2:
       jmp    wloop2
by_wloop2:
       pop    dx
       pop    cx
       inc    dh
       loop   jmp_wloop1
       jmp    by_wloop1
jmp_wloop1:
       jmp    wloop1
by_wloop1:
; have to hid the cursor
       dec    dh
       dec    dh
       add    dl,w
       dec   dl
       dec    dl
       mov    hide,dx
       ret
hide_cursor:
       mov    dx,hide
       mov    ah,2
       mov    bx,0
       int    10h
       mov    bl,color
       and    bl,0f0h
       mov    al,bl
       mov    cl,4
       shr    al,cl
       or     bl,al
       mov    al,0
       mov    ah,9
       mov    cx,1
       mov    bh,0
       int    10h
       ret
do_window    endp
cseg  ends
      end
