print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg
   org  100h
entry: jmp start
; data
istack  db 'HYPE-TEXT text processor',13,10
       db 'Copyright 1988 by Keith P. Graham',13,10,'$'
       db 200 dup(0)  ; total length 270
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
infile  db 64 dup(0)
scr_save dw 25*80 dup(0)
cursor  dw 0
handle  dw 0
buffer  dw 0
lines   dw 0
file_size dw 0
line_no   dw  0
; vwid and vlen are the size of the current panel
vwid      dw  80
vlen      dw  25  ; virtual length of page
; ux and uy are the screen cordinates of the first print area
ux        db  0
uy        db  0
; x and y are the current location?
x         db  0
y         db  0   ; screen line number
curr_line dw  20  ; current line number
color     db  15
line_count dw 0
tline_loop: ;this is for processing the tilde line we have found
; on entry ds:si points to begining of line
      push  cs
      pop   es   ; set up some addressability to data
tl_loop0:
      lodsb
      cmp   al,13
      jne   tl_1
      clc
      ret
tl_1:
      cmp   al,'~'
      je    tl_t
tl_l:
      loop   tl_loop0
      clc
      ret
tl_t:
      lodsb
      cmp   al,13
      jne   tl_2
      clc
      ret
tl_2:
      or   al,60h
; have the first byte after the tilde. It can be a P for panel
; it can be a B for button or a W for window size
;
     cmp   al,'b'
     jne   tl_nb
     stc
     ret   ; with carry for end of current panel
tl_nb:
; check for window
      cmp   al,'w'
     jne   tl_wb
; have the window
     lodsb
     cmp   al,'{'
     jne   tl_t
     call  get_box
tl_wb:
      clc
      ret
get_box:
; loads in the box coordinates
      mov   bx,0
      mov   cx,10
      lodsb
      cmp   al,','
;     je
start:
     lea  sp,istack+268
     call save_screen   ; saves entire screen
     call parse_line    ; gets filename off of command line
     jnc  cont_0
     jmp  end_prog
cont_0:
     call open_file     ; opens input file
     jnc  cont_1
     jmp  end_prog
cont_1:
     call  memory_alloc ; shrinks and allocates the file buffer
     jnc   cont_2
     jmp  end_prog
cont_2:
     call  read_file    ; reads file (up to 64k) into buffer
     jnc   cont_3
     jmp  end_prog
cont_3:
     call  set_lines    ; sets up the linked list of lines
;
     mov   curr_line,0  ; start at top
dloop:
     call  display_page ; show a page
      mov   ah,0
      int    16h        ; wait for key
      cmp  ah,49h
      je   pgup
      cmp  ah,51h
      je   pgdn
      cmp  ah,47h
      je   home
      cmp  ah,4fh
      je   endk
      cmp   al,27
      jne   dloop
end_prog:
     call  restore_screen       ; retore the screen and exit
     int 20h
pgdn:
      mov  ax,vlen
      add  curr_line,ax
      jmp  check_line
pgup:
      mov  ax,vlen
      sub  curr_line,ax
      jmp  check_line
home:
      mov  curr_line,0
      jmp  dloop
endk:
      mov  ax,line_count
      sub  ax,vlen
      mov  curr_line,ax
      jmp  check_line
check_line:
; checks the line number for validity
      cmp  curr_line,0
      jl   home
      mov  ax,line_count
      sub  ax,vlen
      cmp  curr_line,ax
      jg   endk
      jmp   dloop
save_screen:
; save the display
      mov  ah,3 ; get cursor
      mov  bx,0
      mov  cx,0
      int  10h
      mov  cursor,dx
; get current screen
      mov   ah,15
      int   10h
      mov   bx,0b800h
      cmp   al,7  ; mono
      jne   got_col
      mov   bh,0b0h
got_col:
      push  ds
      mov   si,0
      mov   ds,bx
      lea   di,scr_save
      cld
      mov   cx,2000
rep   movsw
      pop   ds
      ret
restore_screen:
      mov  dx,cursor
      mov  ah,2 ; get cursor
      mov  bx,0
      mov  cx,0
      int  10h
; save the display
; get current screen
      mov   ah,15
      int   10h
      mov   bx,0b800h
      cmp   al,7  ; mono
      jne   got_col2
      mov   bh,0b0h
got_col2:
      push  ds
      mov   di,0
      mov   es,bx
      lea   si,scr_save
      cld
      mov   cx,2000
rep   movsw
      pop   es
      ret
display_page:
; top_line has the starting page number
; vlen has the lines per page
; ux has the upper left hand corner of page
   mov al,ux
   mov x,al
   mov al,uy
   mov y,al
   mov ax,curr_line
   mov line_no,ax
   mov cx,vlen
;
dp_loop:
   push cx
   call display_line
   pop  cx
   jc   blank_loop
   inc  y
   inc  line_no
   loop dp_loop
   ret
blank_loop:
   push cx
   mov  cx,80
     mov   dl,cs:x
     mov   dh,cs:y
   call  do_slines
   inc  y
   inc  line_no
   pop  cx
   loop blank_loop
   ret
display_line:
; this displays a line at a location
; location is in x,y
; length is in vwid
; line number is in line_no
;
     push  ds
     push   es
;  setup  the cursor
     mov   dl,x
     mov   dh,y
; now print the line
; dx will have the current location
     mov   cx,vwid
     mov   bx,line_no
     shl   bx,1
     shl   bx,1
     mov   es,lines
     mov   si,word ptr es:[bx]
     cmp   word ptr es:[bx]+2,0
     jne   cont_line2
     mov   cx,80
     push  cx
     jmp   sline_loop
cont_line2:
     mov   ds,word ptr es:[bx]+2
; scan for a tilde or 2
     mov   di,si
     push  es
     push  ds
     pop   es
     push  cx
     mov   al,'~'
repne scasb
     pop   cx
     jne   pline_loop0
     scasb
     je    pline_loop0; if its a double tilde then continue
; we have a tilde on a line
     pop   es
     push  cx
; here we have to process a tilde line
     push   es
     push   ds
     call  tline_loop
     jnc   sl_j
     pop    ds
     pop    es
     pop    cx
     stc
     jmp   done_linesx
sl_j:
     pop    ds
     pop    es
     jmp   sline_loop
pline_loop0:
     pop  es
pline_loop:
; set up for line action
     push  cx
     mov   ah,2 ; locate cursor
     mov   bx,0
     int   10h
     mov   ah,9  ; print at cursor ?
     mov   cx,1
     mov   bh,00
     mov   bl,cs:color
     cld
     lodsb
     cmp   al,13
     je    sline_loop
     cmp   al,'~'
     jne   pl_p
     lodsb
pl_p:
     int   10h
     inc   dl
     pop   cx
     loop  pline_loop
     jmp   done_lines
sline_loop:
; print spaces
     pop  cx
     call  do_slines
done_lines:
     clc
done_linesx:
     pop   es
     pop   ds
     ret
do_slines:
; cx has the remaining bytes to print
     mov   ah,2 ; locate cursor
     mov   bx,0
     int   10h
     mov   ah,9  ; print at cursor ?
     mov   bh,00
     mov   bl,cs:color
     mov   al,20h
     int   10h
     ret
set_lines:
; this passes the data setting up lines
     mov  line_count,0
     push ds
     push es
     mov  cx,file_size
     mov  es,buffer
     mov  di,0
     mov  bx,4
     mov  ds,lines
     mov  word ptr ds:[0],0
     mov  word ptr ds:[2],es
     mov  di,0
     mov  al,10
     cld
look_10:
repne scasb
     jne  end_set_lines
     mov  ds:[bx],di
     mov  ds:[bx+2],es
     inc  cs:line_count
     add  bx,4
     jmp  look_10
end_set_lines:
     mov  word ptr ds:[bx],0
     mov  word ptr ds:[bx+2],0
     mov  word ptr ds:[bx-2],0
     mov  word ptr ds:[bx-4],0
     pop  es
     pop  ds
     ret
read_file:
; get the file into memory
     push  ds
     mov   bx,handle
     mov   dx,0
     mov   cx,0ffffh
     mov   ds,buffer
     mov    ah,3fh
     int    21h
     pop    ds
     jnc    good_read
bad_read:
     print error3
     stc
     ret
good_read:
     cmp    ax,0
     je   bad_read
     mov   file_size,ax
     clc
     ret
memory_alloc:
; allocates memory
; shrink
;
     mov  ah,4ah
     lea  bx,last_byte
     add  bx,15
     shr  bx,1
     shr  bx,1
     shr  bx,1
     shr  bx,1
     int  21h
     jnc  good_shrink
bad_mem:
     print error2
     stc
     ret
good_shrink:
; allocate 64k buffer for file access
     mov  ah,48h
     mov  bx,1000h ; 64k
     int  21h
     jc   bad_mem
     mov  buffer,ax
; allocate the line list
     mov  ah,48h
     mov  bx,800h ; 32k   ; 8000 lines
     int  21h
     jc   bad_mem
     mov  lines,ax
; clean out the line buffer
     mov   ax,0
     push  es
     mov   cx,8000h/2
     cld
     mov   es,lines
     mov   di,0
rep  stosw
     pop    es
     clc
     ret
open_file:
; opens the file for reading
     mov  ax,3d10h
     lea  dx,infile
     int  21h
     jnc  good_open
     print error1
     stc
     ret
good_open:
     mov  handle,ax
     ret
parse_line:
     mov  cl,byte ptr ds:[80h]
     mov  ch,0
     cmp  cx,2
     jge  ok_pcx
bad_pcx:
     print error1
     stc
     ret
ok_pcx:
; set up file
     mov  di,81h
     cld
     mov  al,20h
repe scasb
     je   bad_pcx
     cmp  cx,0
     jle  bad_pcx
     mov  si,di
     dec  si
      inc  cx
     lea  di,infile
pc_1:
     lodsb
     cmp   al,13
     je    pc_2
     cmp   al,20h
     je    pc_2
     stosb
     loop  pc_1
pc_2:
     clc
     ret
last_byte equ this byte
cseg ends
     end entry
