; this program converts from pda into tiff
print macro string
  lea  dx,string
  mov  ah,9
  int  21h
endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
hi db 13,10,'QVERT PDA file converter',13,10
   db       'Copyright 1988 by Keith P. Graham',13,10,'$'
;
err1  db 'Error in command line',13,10,'$'
err2  db 'Invalid switch',13,10,'$'
err3  db 'File(s) not found',13,10,'$'
err4  db 'Memory allocation error',13,10,'$'
err5  db 'Error opening file',13,10,'$'
;
donemess db 13,10,'QVERT finished',13,10,'$'
foundm db 13,10,'Converting file '
pname  db 80 dup(0)
buffer1 dw 0
buffer2 dw 0
handle  dw  0
dswitch db 0
name_start  dw  0
filen_len dw  0
filename db 64 dup(0)
stack  dw 256 dup(0)
dta   equ this byte  ; disk transfer area used for finding files
    db  30 dup(0)
foundfile db 13 dup(0)
;
main      proc     near
; allocate stack
   lea sp,stack+254
   print hi
call parse_line
call memory
;
;
files_loop:
; open the file in the DTA
     call open_file
;
;
;
; done, close file
     call  close_file
     call  get_next
     jmp   files_loop
;
error_exit:
   mov  ah,9
   int  21h
   mov  ax,4cffh
   int  21h
main      endp
get_next:
     mov   ah,4fh
     int   21h
     jc    no_next
     ret
no_next:
     lea   dx,donemess
   mov  ah,9
   int  21h
   mov  ax,4c00h
   int  21h
close_file:
     mov  bx,handle
     mov  ah,3eh
     int   21h
     ret
open_file:
     mov   di,name_start
     lea   si,foundfile
     mov   cx,13
     cld
rep movsb
     lea   dx,filename
     mov   ax,3d00h
     int   21h
     jnc   good_open
     lea   dx,err5
     jmp   error_exit
good_open:
     mov   handle,ax
     lea  si,filename
     lea  di,pname
     cld
mn1:
     lodsb
     cmp  al,0
     je   mn2
     stosb
     jmp  mn1
mn2:
     mov  al,'$'
     stosb
     print foundm
     ret
memory:
; allocate memory
            lea   bx,last_byte
            add   bx,15
            shr   bx,1
            shr   bx,1
            shr   bx,1
            shr   bx,1
            MOV   AH,4ah
            INT   21h
            jnc   ok_shrink
memory_error:
            lea   dx,err4
            jmp   error_exit
ok_shrink:
; allocate the IO buffers - 32k of them (16k for each)
            MOV   AH,48h
            MOV   BX,800h ; 800h*16 = 32k
            INT   21h
            jc    memory_error
            CMP   BX,800h
            JNE   memory_error
            MOV   buffer1,AX
            MOV   AH,48h
            MOV   BX,800h ; 800h*16 = 32k
            INT   21h
            jc    memory_error
            CMP   BX,800h
            JNE   memory_error
            MOV   buffer2,AX
   ret
last_byte equ this byte
parse_line:
; look for a switch
   mov  ch,0
   mov  cl,byte ptr ds:[80h]
   mov  di,81h
   mov  al,'/'
   cld
repne  scasb
   jne  no_switch
   mov  byte ptr ds:[di-1],' '
   mov  al,byte ptr ds:[di]
   mov  byte ptr ds:[di],' '
   cmp  al,'D'
   je   got_d
   cmp  al,'d'
   je   got_d
   lea  dx,err2
   jmp  error_exit
got_d:
   mov  dswitch,1
no_switch:
   mov  ch,0
   mov  cl,byte ptr ds:[80h]
   mov  si,81h
; move in file
   cld
   lea  di,filename
   mov  bx,0
floop0:
   lodsb
   cmp  al,20h
   je   fl1
   cmp  al,13
   je   fl2
   jmp  fl3
fl1:
   loop floop0
fl2:
   lea dx,err1
   jmp  error_exit
fl3:
   stosb
   inc  bx
fl4:
   lodsb
   cmp  al,20h
   je   fl5
   cmp  al,13
   je   fl5
   stosb
   inc  bx
   loop fl4
fl5:
    mov   filen_len,bx
; this is a file spec, we have to list the file
; set dta area
    lea   dx,dta
    mov   ah,1ah
    int   21h
; find first
    lea   dx,filename
    mov  ah,4eh
    mov   cx,0
     int  21h
     jnc  got_first
     lea  dx,err3
    jmp   error_exit
got_first:
; create complete path of guy to change
   lea  di,filename
   add  di,filen_len
   dec  di
   std
   mov  al,'\'
   mov  cx,filen_len
   dec  cx
repne scasb
   jne  no_bslash
   inc  di
   inc  di
   jmp  move_name
no_bslash:
   lea  di,filename
   cmp  filename+1,':'
   jne  move_name
   lea  di,filename+2
move_name:
   cld
   mov  name_start,di
   ret
cseg      ends
          end      start
