#include        <dos.h>
#include        <string.h>
#include        <stdio.h>
#include        <malloc.h>
#include        <ctype.h>

#include        "dbf.h"

canon(char far *,char far *);

D_FIELD fields[] = {
     {"name" , 'c', 8, 0},
    {"ext" , 'c', 3, 0},
    {"size", 'n',10, 0},
    {"date", 'd', 8, 0},
    {"time" , 'c', 8, 0},
    {"attrib" , 'c', 6, 0},
    {"path" , 'c', 128, 0}
} ;

struct DBF *dbf_file ;

char dirspec[128] = "*.*";

struct _find_t find;
char filename[13];
char extension[5];
long int filesize;
char filetime[10];
char filedate[10];
char attribs[6];
char *timestr( unsigned , char * );
char *datestr( unsigned , char * );

char filepath[128];

void main(int pcnt,char *pargs[])
{
    char buff[128];
    int rc,j;
    puts("\nDIRDBF.COM \tVersion 1.0 Copyright 1993 by Keith P. Graham");
    puts("\t\tFor the latest version of this and other programs");
    puts("\t\tCall the Keith Graham Support BBS at (914) 623-0039");

    if(pcnt<2)
    {
	puts("\nFormat: DIRDBF dbfname [dirspec]");
	exit(-1);
    }
    /* add the extension to dbf file (if needed) */
    strcpy(buff,pargs[1]);
    rc=strlen(buff);
    for(j=0;j<rc;j++)
     {
      if(buff[j]=='.')
         break;
     }
    if(buff[j]!='.')
      strcat(buff,".dbf");
    dbf_file =(struct DBF *)calloc(1,sizeof(struct DBF));
    strcpy( dbf_file->filename, buff) ;

    d_create( dbf_file, 7, fields ) ;
    if(pcnt == 3)
	strcpy(dirspec,pargs[2]);

    canon(filepath,dirspec);
    for(j=strlen(filepath)-1;j>=0;j--)
       if (filepath[j]=='\\')
          break;
    filepath[j]=0;
//  rc=_dos_findfirst(dirspec, _A_NORMAL|_A_SUBDIR, &find );
    rc=_dos_findfirst(dirspec,-1, &find );
    while(rc == 0)
    {
	fileinfo(&find);
	d_putfld(dbf_file,1,filename);
	d_putfld(dbf_file,2,extension);
	sprintf(buff,"%10ld",filesize);
	d_putfld(dbf_file,3,buff);
	d_putfld(dbf_file,4,filedate);
	d_putfld(dbf_file,5,filetime);
	d_putfld(dbf_file,6,attribs);
	d_putfld(dbf_file,7,filepath);
	//  char filedate[10];

	d_addrec(dbf_file) ;

	rc=_dos_findnext(&find);
    }
	    d_close( dbf_file ) ;
	    exit(0) ;
}

/* Formats information about a file. */
fileinfo(struct _find_t *pfind )
{
    char *t;
    datestr( pfind->wr_date, filedate );
    timestr( pfind->wr_time, filetime );

    memset(attribs,32,6);
    attribs[6]=0;
    if( pfind->attrib & _A_SUBDIR )
	attribs[0]='D';
    if( pfind->attrib & _A_VOLID )
	attribs[1]='V';
    if(pfind->attrib & _A_RDONLY)
	attribs[2]='R';
    if(pfind->attrib & _A_HIDDEN)
	attribs[3]='H';
    if(pfind->attrib & _A_SYSTEM)
	attribs[4]='S';
    if(pfind->attrib & _A_ARCH)
	attribs[5]='A';

    strcpy(filename,pfind->name);
    t=strtok(filename,". ");
    t=strtok(NULL," ");
    if (t!=NULL)
    strcpy(extension,t);
    else
     extension[0]=0;

    filesize=pfind->size;
    return (0);
}

/* Takes unsigned time in the format:               fedcba9876543210
 * s=2 sec incr, m=0-59, h=23                       hhhhhmmmmmmsssss
 * Changes to a 9-byte string (ignore seconds):     hh:mm ?m
 */
char *timestr( unsigned t, char *buf )
{
    int h,m,s;
    m = (t >> 5) & 0x3f;
    h = (t >> 11) & 0x1f;
    s = t & 0x1f;

    sprintf( buf, "%02.2d:%02.2d:%02.2d", h, m,s);
    return buf;
}

/* Takes unsigned date in the format:               fedcba9876543210
 * d=1-31, m=1-12, y=0-119 (1980-2099)              yyyyyyymmmmddddd
 * Changes to a 9-byte string:                      mm/dd/yy
 */
char *datestr( unsigned d, char *buf )
{
   int yy,mm,dd;
   yy=(d>>9)+1980;
   mm=(d>>5)&0x0f;
   dd=d&0x1f;
    sprintf( buf, "%04.4d%02.2d%02.2d",yy,mm,dd);
    return buf;
}
canon(char far *targ,char far *source)
    /* get a good filespec */
    /* CANONICALIZE a FILESPEC */
{
    _asm {
           push ds;
           push  es;
	   lds   si,source;
           les   di,targ;
           mov   ah,60h
           int   21h;
           pop  es;
           pop  ds;
         }
   return(0);
}
