print macro string
    lea  dx,string
    mov  ah,9
    int  21h
    endm
scount  equ  10
cseg segment para public 'CODE'
   assume cs:cseg,ds:cseg
   org  100h
extrn  compress:near,decompress:near,rle:near,unrle:near
extrn  decompress:near,shrink:near
entry: jmp start
; data
hi   db 'Disk Squeeze 3.0, Copyright 1989 by Keith P. Graham',13,10,10
     db 'This program is free for private use as long as no fee',13,10
     db 'is charged for the program or files created by the program',13,10
     db 'and it is not used by individuals or corporations for profit.',13,10,10,'$'
e1   db 'Command line error. Please refer to documentation.',13,10,'$'
     istack equ this word
e2   db "Can't create target file",13,10,'$'
e3   db 'Error writing target file, Disk full?',13,10,'$'
e6   db 'Error reading sector, Disk may not be squeezable.',13,10,'$'
e6a  db 'Error writing sector, Disk may not be unsqueezable.',13,10,'$'
e7   db "Can't open input file",13,10,'$'
e8   db 'Input file is not a squeezed disk',13,10,'$'
e9   db 'Error reading input file',13,10,'$'
e9a  db 'Input file created by newer version of DSQ.',13,10
     db 'Please call PC-Rockland BBS at (914) 353-2157',13,10
     db 'for latest version',13,10,'$'
e10  db 'Error writing target disk',13,10,'$'
e11  db "Can't read boot record",13,10,'$'
e12  db 'Check Digit error in squeezed disk file',13,10,'$'
e13  db 'Abnormal end of file. Disk may not be complete.',13,10,'$'
e14  db 'Abnormal sector size encountered',13,10,'$'
e15  db 'Command line switch missing or incompatible',13,10,'$'
done db 13,10,'DSQ Done!',13,10,'$'
typeff  db  'FF=5-1/4  Diskette, 2 sides, 8 sectors',13,10,'$'
typefe  db  'FE=5-1/4  Diskette, 1 side, 8 sectors',13,10,'$'
typefd  db  'FD=5-1/4  Diskette, 2 sides, 9 sectors',13,10,'$'
typefc  db  'FC=5-1/4  Diskette, 1 side, 8 sectors',13,10,'$'
typef9  db  'F9=High Density AT 5-1/2 or 3-1/2 720k diskette',13,10,'$'
typef8  db  'F8= Fixed Disk',13,10,'$'
typef0  db  'F0=3-1/2  Diskette, 2 sides, 15 sectors',13,10,'$'
ukdisk  db  'XX= Unknown disk type',13,10,'$'
source  db  'Place source diskette in drive '
sourced db  ' :',13,10
        db  'Press any key to continue.....',13,10,'$'
target  db  'Place target diskette in drive '
targetd db  ' :',13,10
        db  'Press any key to continue.....',13,10,'$'
reading db 'Reading disk. $'
psect   db '0000 total sectors.',13,10,'$'
writing db 'Writing disk. $'
xswitch db 'US01234D'
xswitchl equ 8
switches equ this byte
switchu db 'U'
switchs db 'S'
switch0 db '0'
switch1 db '1'
switch2 db '2'
switch3 db '3'
switch4 db '4'
switchd db 'D'
;
hash_seg dw 0
stack_seg dw 0
buffer1 dw 0
buffer2 dw 0
buffer3 dw 0
buffer4 dw 0
public hash_seg,stack_seg,buffer1,buffer2,buffer3,buffer4
handle  dw 0
buffer1size dw 0  ; size of data in buffer1
buffer2size dw 0  ; size of data in buffer2
buffer3size dw 0  ; size of data in buffer3
buffer4size dw 0  ; size of data in buffer4
curr_buff  dw 0
curr_buff_size dw 0
public curr_buff,curr_buff_size
targ_buff  dw 0
targ_buff_size dw 0
public targ_buff,targ_buff_size
check_dig  dw 0
diskt  db 0
;
;
sig    db 26,'KPG'
ver    dw 300
sectors  dw 0  ; count of sectors on the source diskette
disktype db 0
;
;
disk   db 0
filename  db 64 dup(0)
comp_type db 0 ; compression type 3 bytes with fcount
fcount dw 0
bcount dw 0
rcount dw 0
;
;
;
start:
;
     print hi
     call parse
     lea  sp,istack-2
     mov  ax,0
     push ax
     call  shrink
     mov   ax,stack_seg
     mov   ss,ax
     mov   sp,0ff00h
     cmp  switchs,1
     je   do_squeezex
     cmp  switchu,1
     je   do_unsqueezex
     cmp  switchd,1
     je   do_dir
do_unsqueezex:
     mov  al,disk
     add  al,41h
     mov  targetd,al
     print target
     mov  ah,0ch
     mov al,1
     int  21h
     jmp  do_unsqueeze
do_squeezex:
     mov  al,disk
     add  al,41h
     mov  sourced,al
     print source
     mov  ah,0ch
     mov al,1
     int  21h
     jmp  do_squeeze
do_dir:
;
;
;
     int  20h
;
;
;
;   0 = no_sqeeze
;   1 = rle
;   2 = lzw
;   3 = lzw on top of rle
;
get_buff:
; on decompress the file starts in buffer2
; and is deposited in buffer1
     mov   ax,curr_buff_size
     mov   buffer1size,ax
     cmp   comp_type,'0'
     je    dcomp0
     cmp   comp_type,'1'
     je    dcomp1
     cmp   comp_type,'2'
     je    dcomp2
     cmp   comp_type,'3'
     je    dcomp3
     cmp   comp_type,'4'
     je    dcomp4
dcomp0:
    jmp   dcomp_end
dcomp1:
    mov   ax,buffer2
    mov   targ_buff,ax
    call  unrle
    mov   ax,buffer2
    mov   curr_buff,ax
    mov   ax,targ_buff_size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp2:
    mov   ax,buffer3
    mov   targ_buff,ax
    call   decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,targ_buff_size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp3:
    mov   ax,buffer3
    mov   targ_buff,ax
    call  decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,targ_buff_size
    mov   curr_buff_size,ax
    mov   ax,buffer2
    mov   targ_buff,ax
    call  unrle
    mov   ax,buffer2
    mov   curr_buff,ax
    mov   ax,targ_buff_size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp4:
    mov   ax,buffer3
    mov   targ_buff,ax
    call  decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,targ_buff_size
    mov   curr_buff_size,ax
dcomp_end:
     ret
do_unsqueeze:
     mov   ax,buffer1
     mov   curr_buff,ax
     call  open_in  ; opens the input file
     mov   ax,sectors
     mov   cx,scount
     add   ax,sectors
     dec   ax
     mov   dx,0
     div   cx
     mov   dx,0
     mov   cx,ax
uns_top:
     push  cx
     push  dx
     mov   al,'.'
     mov   ah,14
     int   10h
     call  reset_disks
     pop   dx
     push  dx
     mov   ax,buffer1
     mov   curr_buff,ax
     call  read_file
     cmp   ax,0
     je    uns_error
     call   get_buff
     mov   ax,curr_buff_size
     mov   dx,0
     mov   cx,512
     div   cx
     cmp   dx,0
     jne   uns_errora
     mov   bcount,ax
     pop   dx
     call  write_segs
     add   dx,bcount
     cmp   dx,sectors
     jge   uns_end
uns_bot:
     pop   cx
     loop  uns_top
uns_end:
     print done
     int   20h
uns_errora:
     print e14
     int  20h
uns_error:
     print e13
     int  20h
reset_disks:
     push  dx
     mov  ah,0dh
     int  21h
     pop  dx
     ret
write_segs:
; this writes out the segments
; dx has the current sector to write
    push  dx
    mov   cx,512
    mov   dx,0
    mov   ax,curr_buff_size
    div   cx
    mov   bcount,ax
    mov   cx,ax
    mov   al,disk
    mov   bx,0
    pop   dx
    push  dx
    call  ws
    pop   dx
    jc    bad_segs
    ret
bad_segs:
    print  e10
    int   20h
ws:
    mov   bp,5
ws_loop:
    push  bp
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   ds,curr_buff
    int   26h
    jc    bad_ws
    add   sp,2
    pop   ds
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    pop   bp
    clc
    ret
bad_ws:
    add   sp,2
    pop   ds
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    pop   bp
    dec   bp
    cmp   bp,0
    jge   ws_loop
    print e6a
    stc
    ret
read_file:
     push  dx
; this reads the next block of records into buffer2
     lea  dx,comp_type
     mov  cx,3
     mov  bx,handle
     mov  ah,3fh
     int  21h
     cmp  ax,3
     je   good_rf
bad_rf:
     mov  ax,0
     stc
     pop  dx
     ret
good_rf:
     lea   dx,check_dig
     mov  cx,2
     mov  bx,handle
     mov  ah,3fh
     int  21h
     jc   bad_rf
     cmp  ax,2
     jne  bad_rf
     mov  cx,fcount
     mov  curr_buff_size,cx
     mov  dx,0
     mov  bx,handle
     mov  ah,3fh
     push ds
     mov  ds,curr_buff
     int  21h
     pop  ds
     jc   bad_rf
     cmp  ax,cx
     jne  bad_rf
     mov  cx,fcount
     mov  si,0
     mov  bx,0
     mov  ah,0
     push ds
     mov  ds,buffer1
chk_dig2:
     lodsb
     add  bx,ax
     loop chk_dig2
     pop  ds
     pop  dx
     cmp  bx,check_dig
     jne  bad_check_dig
     mov   ax,fcount
     ret
bad_check_dig:
     print  e12
     int  20h
open_in:
     lea   dx,filename
     mov   ah,3dh
     mov   cx,0
     mov   al,0
     int   21h
     jnc   good_oi
     print e7
     int  20h
good_oi:
     mov  handle,ax
     mov  cx,9
     lea  dx,sig
     mov  bx,handle
     mov  ah,3fh
     int   21h
     jnc   good_r1
bad_r1:
     print  e8
     int   20h
bad_ver:
     print  e9a
     int   20h
good_r1:
     cmp   ax,9
     jne   bad_r1
     cmp   sig,26
     jne   bad_r1
     cmp   ver,300
     jg    bad_ver
     cmp  word ptr sig+1,'PK'
     jne   bad_r1
     mov   ax,sectors
     call  format_sectorsw
     ret
do_squeeze:
     call  create
     mov   ax,buffer1
     mov   curr_buff,ax
     call  chkdsk
     mov   ax,sectors
     add   ax,scount-1
     mov   cx,scount
     mov   dx,0
     div   cx
     mov   cx,ax
     mov   dx,0
sq_loop:
     push   cx
     push   dx
     mov    al,'.'
     mov    ah,14
     int    10h
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    buffer1size,512*scount
     mov    curr_buff_size,512*scount
     call   get_sector
     call   setup_sq
     pop    dx
     push   dx
     call   write_sector
     pop    dx
     add    dx,bcount
     sub    sectors,scount
     pop    cx
     cmp    sectors,0
     jle    end_sq
     loop   sq_loop
end_sq:
     print done
     int 20h
setup_sq:
; here we have to look at switches in order to tell how to squeeze
;
;   0 = no_sqeeze
;   1 = rle
;   2 = lzw
;   3 = lzw on top of rle
;
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    cx,512
     mov    ax,bcount
     mul    cx
     mov    buffer1size,ax
     mov    curr_buff_size,ax
     cmp   switch0,1
     je    do_comp0
     cmp   switch1,1
     je    do_comp1
     cmp   switch2,1
     je    do_comp2
     cmp   switch3,1
     je    do_comp3
do_comp0:
; comp0 is no compression
     mov    comp_type,'0'
done_c2:
     jmp    done_comp
do_comp1:
; comp1 is rle only copies into buffer2 from curr_buff
     mov    ax,buffer2
     mov    targ_buff,ax
     call   rle
check_comp1:
     mov    ax,buffer2
     mov    curr_buff,ax
     mov    ax,targ_buff_size
     mov    curr_buff_size,ax
     mov    buffer2size,ax
     mov    comp_type,'1'
     cmp    ax,buffer1size  ; is the current buffersize less than uncomp
     jl     done_c2
     mov    comp_type,'0'
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
     jmp    done_comp
do_comp2:
; comp2 is lzw only. lzw copies into buffer3
     mov    ax,buffer3
     mov    targ_buff,ax
     call   compress
     mov    ax,buffer3
     mov    curr_buff,ax
     mov    ax,targ_buff_size
     mov    buffer3size,ax
     mov    curr_buff_size,ax
     mov    comp_type,'2'
     jmp    done_comp
do_comp3:
; comp3 is lzw of rle
     mov    ax,buffer2
     mov    targ_buff,ax
     call   rle
     mov    comp_type,'3'
     mov    ax,buffer2
     mov    curr_buff,ax
     mov    ax,targ_buff_size
     mov    buffer2size,ax
     mov    curr_buff_size,ax
     add    ax,512
     cmp    ax,buffer1size
     jl     compc3
     mov    comp_type,'4'
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
compc3:
     mov    ax,buffer3
     mov    targ_buff,ax
     call   compress
     mov    ax,buffer3
     mov    curr_buff,ax
     mov    ax,targ_buff_size
     mov    curr_buff_size,ax
     mov    buffer3size,ax
     cmp    ax,buffer2size   ; should we use the comp3?
     jl     done_comp
     jmp    check_comp1
done_comp:
     mov    ax,curr_buff_size
     mov    fcount,ax
     ret
get_boot:
; like get sector, but reads the boot recor only
    mov   cx,5
b1:
    push  cx
    mov   dx,0
    mov   al,disk
    mov   cx,1
    mov   bx,0
    push  ds
    mov   ds,curr_buff
    int   25h
    jnc   b2
    add   sp,2
    pop   ds
    pop   cx
    loop  r1
    print e6
    jmp   b3
b2:
    add   sp,2
    pop   ds
    pop   cx
    clc
    ret
b3:
    stc
    ret
get_sector:
; gets the sector in dx
    push  dx
    mov   cx,5
r1:
    push  cx
    push  dx
    mov   al,disk
    mov   cx,scount
    mov   bcount,cx
    cmp   sectors,cx
    jge   r1a
    mov   cx,sectors
r1a:
    mov   bcount,cx
    mov   bx,0
    push  ds
    mov   ds,curr_buff
    int   25h
    jnc   r2
    add   sp,2
    pop   ds
    pop   dx
    pop   cx
    loop  r1
    print e6
    jmp   r3
r2:
    add   sp,2
    pop   ds
    pop   dx
    pop   cx
r3:
    pop   dx
    ret
write_sector:
; cx has the number of bytes to write
     push  dx
     lea   dx,comp_type
     mov   cx,3
     mov   ah,40h
     mov  bx,handle
     int   21h
     mov   cx,curr_buff_size
     mov   si,0
     mov   bx,0
     mov   ah,0
     push  ds
     mov   ds,curr_buff
chk_loop:
     lodsb
     add   bx,ax
     loop  chk_loop
     pop   ds
     mov   check_dig,bx
     lea   dx,check_dig
     mov   cx,2
     mov   ah,40h
     mov  bx,handle
     int   21h
     mov   cx,curr_buff_size
     mov   dx,0
     mov   ah,40h
     mov   bx,handle
     push  ds
     mov   ds,curr_buff
     int   21h
     pop   ds
     cmp   ax,cx
     jne   error4
     pop   dx
     ret
error4:
    pop   dx
    jmp   error3
; this reads the sector 0 of a disk and thinks about it
get_disk_type:
; system reset
    mov   ah,0dh
    int    21h
; get drive data on source
     push  ds
     mov  dl,disk
     inc  dl
     mov  ah,1ch
     int  21h
     mov  bl,byte ptr ds:[bx]
     pop  ds
     mov  diskt,bl
; print out known disk types
     call  print_dtype
     ret
print_dtype:
     mov   al,diskt
     lea   dx,typeff
     cmp   al,0ffh
     je    printd
     lea   dx,typefe
     cmp   al,0feh
     je    printd
     lea   dx,typefd
     cmp   al,0fdh
     je    printd
     lea   dx,typefc
     cmp   al,0fch
     je    printd
     lea   dx,typef9
     cmp   al,0f9h
     je    printd
     lea   dx,typef8
     cmp   al,0f8h
     je    printd
     lea   dx,typef0
     cmp   al,0f0h
     je    printd
uk:
; unknow type convert to hex
     mov   ah,0
     mov   cl,16
     div   cl
     or    ax,3030h
     cmp   ah,39h
     jle   check_al
     add   ah,7
check_al:
     cmp   al,39h
     jle   done_hex
     add   al,7
done_hex:
     mov   word ptr ukdisk,ax
     lea   dx,ukdisk
printd:
     mov   ah,9
     int   21h
     ret
chkdsk:
     call  get_disk_type
     mov  bl,diskt
     mov  disktype,bl
; read sector 0
     call   get_boot
     jnc   got_boot
     print  e11
     int    20h
got_boot:
     push  ds
     mov   ds,curr_buff
     mov   ax,word ptr ds:[13h]  ; sector
     pop   ds
;
; ax has the total number of sectors
     mov   sectors,ax
   call format_sectorsr
; write out the header
     mov  cx,9
     lea  dx,sig
     mov  bx,handle
     mov  ah,40h
     int   21h
     cmp   ax,9
     jne   error3
     ret
error3:
     print e3
     int   20h
create:
     lea  dx,filename
     mov  cx,0
     mov  ax,3c00h
     int  21h
     jc   bad_create
     mov   handle,ax
     ret
bad_create:
     print e2
     int   20h
format_sectorsr:
; ax has the count of sectors
     push  ax
     push  cx
     push  dx
     print reading
     jmp   format_sectors
format_sectorsw:
; ax has the count of sectors
     push  ax
     push  cx
     push  dx
     print writing
format_sectors:
     pop   dx
     pop   cx
     pop   ax
; ax has the count of sectors
     push  ax
     push  cx
     push  dx
     mov   dx,0
     mov   cx,100
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     mov   word ptr psect,ax
     mov   ax,dx
     mov   dx,0
     div   cl
     or    ax,3030h
     mov   word ptr psect+2,ax
     print psect
     pop   dx
     pop   cx
     pop   ax
     ret
get_switch:
; this sets up switches
    mov  bx,0
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
gs_loop:
    mov  al,'/'
    cld
repne scasb
    jne  no_switch
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    push  cx
    push  di
    cmp   al,'a'
    jl    upper
    sub   al,32
upper:
    lea   di,xswitch
    mov   cx,xswitchl
    cld
repne scasb
    jne   bad_switch
    sub   di,offset xswitch+1
    mov   switches[di],1
    pop   di
    pop   cx
    inc   bx
    jmp   gs_loop
no_switch:
    cmp  bx,0
    jg   check_switch
bad_switch:
    print  e1
    int   20h
check_switch:
; one or more switch has been set
; d switch is only good by itself and has no disk
     cmp   switchd,1
     jne   no_d
     cmp   bx,1
     jne   bad_switch
     jmp   switch_ok
no_d:
; s and u are incompatible
     cmp   switchs,1
     je    got_s
     cmp   switchu,1
     je    got_u
switch_err:
    print  e15
    int   20h
got_u:
     cmp   bx,1
     jne   bad_switch
     jmp   switch_ok
got_s:
; only 1 2 or 3 at once no two
     cmp   switchu,1
     je   switch_err
     cmp   switch0,1
     jne   check1
     cmp   switch1,1
     je    switch_err
     cmp   switch2,1
     je    switch_err
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check1:
     cmp   switch1,1
     jne   check2
     cmp   switch2,1
     je    switch_err
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check2:
     cmp   switch2,1
     jne   check3
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check3:
     cmp   switch3,1
     je    switch_ok
; no switch for compression, use 1 - fastest
     mov   switch1,1
switch_ok:
     ret
p_error:
    print  e1
    int   20h
parse:
    call  get_switch
    lea   di,filename
    mov  si,81h
    mov  bx,0
    cld
    cmp   switchd,1
    je    p5
p1:
    lodsb
    cmp  al,20h
    je   p1
    cmp  al,9
    je   p1
    cmp  al,13
    je   p_error
p2:
    cmp   al,'Z'
    jle   p3
    sub   al,32
p3:
    cmp  al,'A'
    jge   p4
    jmp   p_error
p4:
    sub   al,'A'
    mov   disk,al
    lea   di,filename
    mov   bl,0
    lodsb
    cmp   al,':'
    jne   p_error
    lodsb
    cmp   al,' '
    jne   p_error
p5:
    lodsb
    cmp   al,13
    je    p_error
    cmp   al,' '
    je    p5
    cmp   al,9
    je    p5
p6:
    cmp   al,'.'
    jne   p6a
    mov   bl,1
p6a:
    stosb
    lodsb
    cmp   al,' '
    je    done_p
    cmp   al,13
    jne   p6
done_p:
    cmp   bl,0
    je    p7
    ret
p7:
    mov  ax,'D.'
    stosw
    mov  ax,'QS'
    stosw
    ret
cseg ends
     end entry
