; these are the graphics routines which will be called by C
;       port address
index       equ       03b4h
cntrl       equ       03b8h
;       control codes
scrn_on       equ       8
grph      equ       2
text      equ       20h
cseg       segment para public 'CODE'
      assume   cs:cseg,ds:cseg
      
mode   db  0
vbuffer dw 0a000h
interlace dw 1
vid_wid dw 80
vid_len dw 480
public mode,vbuffer,interlace,vid_wid,vid_len
attcopy     DB    'C)   OLIVETTI 1984' ;AT&T bios copyright
gtable      DB    35h,2dh,2eh,07h ;hecules graphics mode table
            DB    5bh,02h,57h,57h
            DB    02h,03h,00h,00h
;
_GRAPHICS_HALF proc near
public _graphics_half
; This takes a string and a length and halves the length of the
; string returning a new length
       push bp
       mov  bp,sp
      push  bx
      mov   bx,[bp+4] ; passed location of string
      mov   cx,[bp+6] ; length of string
      mov   bp,es
      push  si
      push  di
;
      mov   si,bx
      mov   di,bx
      mov   bx,0
      shr   cx,1
      mov   bx,cx
      cmp   cx,0
      jg    hloop0
      mov   cx,1
      mov   bx,1
hloop0:
      cld
      lodsb
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      lodsb
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      shl  ax,1
      shl  al,1
      mov  al,ah
      stosb
      loop  hloop0
      mov  ax,bx
;
      pop   di
      pop   si
      pop   bx
      pop   bp
      ret
_GRAPHICS_HALF endp
_GRAPHICS_LINE proc near
public _graphics_line
; this puts a line of graphics on the screen
       push bp
       mov  bp,sp
      push  bx
      mov   ax,[bp+4] ; passed line number
      mov   bx,[bp+6] ; passed location of string
      mov   cx,[bp+8] ; length of string
      mov   bp,es
      push  si
      push  di
      push  ds
      push  es
      push  cx
      call  reset_segs
      mov   dx,0
      div   interlace
      cmp   ax,vid_len
      jg    end_screen
; if there is an interlace line it is in a remainder in dx
      push  ax
      mov   ax,dx
      mov   cx,200h  ; distance between interlaces
      mul   cx
      add   ax,vbuffer
      mov   es,ax
      pop   ax        ; lines down
      mul   vid_wid
      mov   di,ax
      mov   ds,bp
      mov   si,bx
      pop   cx
      cld
rep   movsb
;
;
     mov  ax,0
     jmp  exit_gline
end_screen:
      pop   cx
      mov   ax,-1
exit_gline:
      pop   es
      pop   ds
      pop   di
      pop   si
      pop   bx
      pop   bp
      ret
_GRAPHICS_LINE endp
screens   equ this word
      dw  4,setmed
      dw  6,sethires
      dw  15,setega0f
      dw  16,setega10
      dw  17,setvga11
      dw  18,setvga12
      dw  25h,setnec
      dw  40h,setatt
      dw  43h,setherc
      dw  50h,setpara
      dw  53h,do_vip53
      dw  59h,do_gen59
      dw  73h,do_gen73
      dw  7ch,do_gen7c
      dw  88h,set640
      dw  0c8h,set1280
      dw  0ffffh,0   ; stopper
;
_set_graphics proc near
; this routine sets a graphics mode based on the mode passed
public _set_graphics
      push  bp
      mov   bp,sp
      push  bx
      mov   bx,[bp+4] ; passed mode
      push  si
      push  di
      push  ds
      push  es
      call  reset_segs
     mov   mode,bl
    lea   si,cs:screens
    cld
try_mode:
     mov   ax,cs:[si]
     cmp   ax,bx
     je    do_mode
     cmp   ax,0ffffh
     je    set_bx_mode
     add   si,4
     jmp   try_mode
do_mode:
     mov   mode,0
     call  cs:[si+2]
     jmp  exit_set
set_bx_mode:
     call  set_mode
exit_set:
;
      mov   al,mode
      mov   ax,0
      pop   es
      pop   ds
      pop   di
      pop   si
      pop   bx
      pop   bp
      ret
_set_graphics endp
;
_curr_mode      proc     near
; this routine returns the current graphics mode
public _curr_mode
      push  bp
      mov   bp,sp
      push  bx
;
      mov   ah,15
      int   10h
      mov   ah,0
      pop   bx
      pop   bp
      ret
_curr_mode      endp
;
;
;
_get_best_mode  proc near
public _get_best_mode
      push  bp
      mov   bp,sp
      push  bx
      push  si
      push  di
      push  ds
      push  es
      call  reset_segs
;
; check to see mode on entry, if it is 7 for mono try ega mono
; and if that doesn't work try herc
;
      mov   ah,15
      int   10h
      cmp   al,7
      jne   not_mono
; enter in monochrome, the obvious guys are ega11, vga and herc
; we got mono, we have to try to see if the ega is here
      call  check_ega
      jc    not_egam
      mov   mode,0fh
      call  check_vga
      jc    exit_best
      mov   mode,11h
      jmp   exit_best
not_egam:
      call  check_herc
      jc    not_mono
      mov   mode,43h
      jmp   exit_best
not_mono:
      CALL  check_att
      JC    try_vga    ; all has failed, try again for color
      MOV   mode,40h
      jmp   exit_best
try_vga:
; check for EGA color
      call  check_ega
      jc    try_cga
      mov   mode,10h
      call  check_vga
      jc    exit_best
      mov   mode,12h
      jmp   exit_best
try_cga:
; no choice here, must set cga Hi
      mov  mode,6 ; black and white hires

;

exit_best:
      mov   al,mode
      mov   ah,0
      pop   es
      pop   ds
      pop   di
      pop   si
      pop   bx
      pop   bp
      ret
_get_best_mode  endp
gsets proc near
reset_segs:
public reset_segs
      push  ax
      mov   ax,cs
      mov   ds,ax
      mov   es,ax
      pop   ax
      ret
set_mode:
; just issues interrupt 10h to make sure bios knows our mode
;
      MOV   AH,0
      MOV   AL,mode
      INT   10h
      RET
;
do_vip53:
      MOV   mode,53h
      MOV   vbuffer,0a000h
      MOV   vid_wid,100
      MOV   vid_len,560
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
do_gen59:
      MOV   mode,59h
      MOV   vbuffer,0a000h
      MOV   vid_wid,90
      MOV   vid_len,512
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
do_gen73:
      MOV   mode,73h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,480
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
do_gen7c:
      MOV   mode,7ch
      MOV   vbuffer,0a000h
      MOV   vid_wid,64
      MOV   vid_len,512
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setvga11:
      MOV   mode,11h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,480
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setvga12:
      MOV   mode,12h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,480
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setvga13:
      MOV   mode,13h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80*8
      MOV   vid_len,400
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setnec:
      MOV   mode,25h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,480
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setpara:
      MOV   mode,50h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,480
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
set1280:
; this sets the amdek 1280 mode
      MOV   AL,0c8h     ;1280x800 mode even bank
      MOV   DX,3dfh     ; native ocntrol port
      OUT   DX,AL
; set the start addresses to 0 for each bank
      MOV   AL,0
      MOV   DX,3ddh
      OUT   DX,AL
      MOV   AL,0
      MOV   DX,3deh
      OUT   DX,AL
; set the vid and other parameters
      MOV   mode,0c8h
      MOV   vbuffer,0a000h
      MOV   vid_wid,160
      MOV   vid_len,400
      MOV   interlace,1
      CALL  set_mode
      RET
set640:
; this sets the amdek 640  mode
      MOV   AL,088h     ;640x400 mode even bank
      MOV   DX,3dfh     ; native ocntrol port
      OUT   DX,AL
; set the start addresses to 0 for each bank
      MOV   AL,0
      MOV   DX,3ddh
      OUT   DX,AL
      MOV   AL,0
      MOV   DX,3deh
      OUT   DX,AL
; set the vid and other parameters
      MOV   mode,088h
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,400
      MOV   interlace,1
      CALL  set_mode
      RET
sethires:
; back to graphics
      MOV   mode,6
      MOV   vbuffer,0b800h
      MOV   vid_wid,80
      MOV   vid_len,100
      MOV   interlace,2
      CALL  set_mode
      RET
setherc:
      MOV   mode,43h
      MOV   vbuffer,0b000h
      MOV   vid_wid,90
      MOV   vid_len,87
      MOV   interlace,4
      CALL  set_mode
      CALL  hgmode
      CLC
      RET
setmed:
; back to graphics
      MOV   mode,4
      MOV   vbuffer,0b800h
      MOV   vid_wid,80
      MOV   vid_len,100
      MOV   interlace,2
      CALL  set_mode
      RET
check_vga:
; this checks to see of the VGA is present by doing a vga only
; call and sets the carry flag accordingly
      mov   ax,1a00h
      int   10h
      cmp   al,1ah
      jne   no_vga
      clc
      ret
no_vga:
      stc
      ret
check_herc:
; this does a check to see if hercules mode is possible
; ega and vga must have failed before this is attempted
      mov  bx,0b000h   ; mono segment
      push es
      mov  es,bx
      mov  ax,word ptr es:[7000] ; if ordinary mono does not exist
      mov  cx,01010101b
      mov  word ptr es:[7000],cx
      cmp  word ptr es:[7000],cx
      jne  not_hercules
      xor  word ptr es:[7000],cx
      xor  cx,cx
      cmp  word ptr es:[7000],cx
      jne  not_hercules
      mov  word ptr es:[7000],"ho"
      cmp  word ptr es:[7000],"ho"
      jne  not_hercules
      mov  word ptr es:[7000],ax
      pop  es
      clc
      ret
not_hercules:
      pop  es
      stc
      ret
check_ega:
; this does a check for ega and sets carry if not present
; this will only work if the EGA is present
      MOV   AX,1200h
      MOV   BX,10h
      MOV   CX,0ffffh
      INT   10h
      CMP   CX,0ffffh
      JNE   there_is_ega
      STC
      RET
there_is_ega:
      clc
      ret
setega0f:
      MOV   mode,15
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,350
      MOV   interlace,1
      CALL  set_mode
      CLC
      RET
setega10:
      MOV   mode,16
      MOV   vbuffer,0a000h
      MOV   vid_wid,80
      MOV   vid_len,350
      MOV   interlace,1
      MOV   DX,3ceh
      MOV   AL,8
      OUT   DX,AL
      INC   DX
      MOV   AL,0ffh     ;6?
      OUT   DX,AL
      MOV   DX,3c4h
      MOV   AL,2
      OUT   DX,AL
      INC   DX
      MOV   AL,00fh
      OUT   DX,AL
      MOV   AX,0a000h
      PUSH  ES
      MOV   ES,AX
      MOV   DI,0
      MOV   CX,08000h
      MOV   AX,0
      CLD
REP       STOSW
      POP   ES
      CALL  set_mode
      CLC
      RET
check_att:
; this is where the att detection goes
      PUSH  ES
      MOV   AX,0fc00h
      MOV   ES,AX
      MOV   DI,40h
      CLD
      MOV   AL,28h
      MOV   CX,32
REPNE       SCASB
      JNE   notatt
      LEA   SI,DS:attcopy
      MOV   CX,17
repe      CMPSB
      JNE   notatt
      JMP   attnext
notatt:
      POP   ES
      STC
      RET
attnext:
      POP   ES
      clc
      ret
setatt:
      MOV   mode,40h
      MOV   vbuffer,0b800h
      MOV   vid_wid,80
      MOV   vid_len,100
      MOV   interlace,4
      CALL  set_mode
      CLC
      RET
 
hgmode:
      PUSH  AX
      PUSH  BX
      PUSH  CX
      PUSH  DX
      PUSH  BP
      PUSH  SI
      PUSH  DI
      PUSH  ES
      MOV   DX,3bfh
      MOV   AL,3
      OUT   DX,AL
      mov     al,grph
      lea     si,DS:gtable
      mov     bx,0
      mov     cx,4000h
      call    setmd
      POP   ES
      POP   DI
      POP   SI
      POP   BP
      POP   DX
      POP   CX
      POP   BX
      POP   AX
      ret
; sets herc graphics mode
setmd:
;     sets mode to graphics or text
;     depending on al
;     si = parameter table
;     cx = number of words to be cleared
;     bx = blank value
      push    ax
      push    bx
      push    cx
;     change mode but without scrn_on
      mov     dx,cntrl
      out     dx,AL
;     intialize the 6845
      mov     dx,index
      mov     cx,12       ;12 parameters to
      ;be output
      xor     ah,ah       ;starting from
      ;reg. 0
parms:  mov     al,AH
      out     dx,al       ;output register
      ;number
      cld
      inc     dx
      lodsb
      out     dx,al       ;output data
      inc     ah       ;next value
      dec     dx
      loop    parms
      pop     cx       ;clear the buffer
      mov     ax,0b000h
      mov     es,AX
      xor     di,DI
      pop     ax
      rep     stosw
      mov     dx,cntrl
      pop     ax
      add     al,scrn_on
      out     dx,AL
      ret
gsets  endp
cseg       ends
      END
