; these routines read the config file and parse it setting
; various switches
config_file db "CONFIG.DW"
            db 64 dup(0)  ; pad for provided name
param1   db 32 dup(0)
param2   db 32 dup(0)
param3   db 32 dup(0)
param4   db 32 dup(0)
param5   db 32 dup(0)
param6   db 32 dup(0)
errc1 db 13,10,'Error opening Configuration file, job cancelled',13,10,'$'
errc2 db 13,10,'Unrecognized paramter in config file, ignored',13,10,'$'
handle   dw 0
fbuffer  db 256 dup(0)
replace_num  db 0  ; number of paramter used in replacement
replace_si   dw 0  ; loaction in replacement paramter
switch  db  0
switch1 db  0
dw_config proc near
; start parsing the command.line
       call  parse_command_line
; command_line is parsed, now open the config file and check for
; the parameters
;
; open the config file
       call  open_config
; read in 256 bytes a time
       mov  cx,0
; parse out stuff
;
; fbuffer has 256 bytes
;
check_param:
       call  fgetbyte
       jnc   check_param1
leave_config:
       call  close_file
       ret
bad_paramx:
   jmp   bad_param
check_param1: ; check here for first byte of param
       cmp   al,13
       je    check_param
       cmp   al,':'
       jne   not_colon
       cmp   switch1,0  ; reached second partition after setting
; finished have to go home
       jne   leave_config
not_end_colon:
       cmp   switch,0
       jne   check_switch1
       mov   switch1,0ffh
       jmp   run_out
check_switch1:
       call  fgetbyte
       jc    leave_config
       cmp   al,switch
       jne   check_switch2
; switch is equal to partition
       mov   switch1,al
       jmp   run_out
check_switch2:
; switches are not equal
       jmp   run_out
not_colon:
; check to see if we are in a valid partition
       cmp  switch,0
       je   by_part
       cmp  switch1,0
       jne  by_part
       jmp  run_out
by_part:
       cmp   al,'C'
       jne   not_C
; looking for COM1 or COM2, CTTY or CD=
       call  fgetbyte
       jc    leave_config
       cmp   al,'D'
       je   got_cd
       cmp   al,'T'
       je   got_ct
       cmp   al,'O'
       jne   bad_paramx
       call  fgetbyte
       jc    leave_config
       cmp   al,'M'
       jne   bad_paramx
       call  fgetbyte
       jc    leave_config
       cmp   al,'1'
       je    got_com_num
       cmp   al,'2'
       jne   bad_param
got_com_num:
       sub   al,31h
       mov   comport,al
       jmp   run_out
not_c:
       cmp   al,'D'
       jne   not_D
       call  fgetbyte
       jc    leave_configx
       cmp   al,'O'
       jne   bad_param
       call  fgetbyte
       jc    leave_configx
       cmp   al,'='
       jne   bad_param
;      have the DO parameter
       lea  di,command_line
       mov  al,4
       stosb
       mov  ax,"/ "
       stosw
       mov  ax," C"
       stosw
do_loop:
       call  fgetbyte
       jc    leave_configx
       stosb
       inc   command_line
       cmp   al,13
       je   check_paramx
       jmp   do_loop
got_ct:
       jmp   set_ct
got_cd:
       call  fgetbyte
       jc    leave_configx
       cmp   al,'='
       jne   bad_param
       call  get_num
       mov   wcount,bx
       mov   ticker,1
       cmp   al,13
       jne   run_out
       jmp   check_paramx
not_D:
; here we have an unrecognized command
       cmp   al,'V'
       jne   not_V
       mov   video,1
       jmp   run_out
check_paramx:
     jmp  check_param
leave_configx:
     jmp  leave_config
not_v:
bad_param:
       print errc2
; run out till a 13 is found
run_out:
       call  fgetbyte
       jnc   check_13
bad_run:
       jmp   leave_configx
check_13:
       cmp   al,13
       jne   run_out
       jmp   check_paramx
set_ct:
; got the CTTY parameter
       mov   ctty,1
       jmp   run_out
;
;
;==========================================
;
get_num:
; this gets a number and computes it in bx
       mov   bx,0
next_num:
       call  fgetbyte
       jnc   check_num
       mov   al,13
       stc
leave_num:
       ret
ten   dw  10
check_num:
; check for a numeric
       cmp   al,13
       je    leave_num
       cmp   al,20h
       je    leave_num
       cmp   al,'0'
       jl    leave_num
       cmp   al,'9'
       jg    leave_num
       and   al,0fh
       mov   ah,0
       xchg  bx,ax
       mul   ten
       add   ax,bx
       mov   bx,ax
       jmp   next_num
parse_command_line:
; first thing to do is search for the / character
;
       mov   cl,byte ptr ds:[80h]
       mov   ch,0
       cmp   cx,1
       jg    is_command_line
       stc
       ret
is_command_line:
       mov  di,81h
       cld
       mov  al,'/'
repne  scasb
       jne   no_slash
       mov  byte ptr ds:[di-1],' '
       mov  si,di
       lodsb
       mov  byte ptr ds:[di],' '
       cmp  al,'Z'
       jl   got_switch
       sub  al,32
got_switch:
       mov  switch,al
no_slash:
; parse the line
       mov   cl,byte ptr ds:[80h]
       mov   ch,0
       lea   di,config_file
       mov   si,81h
       call  parse_c
       jc    no_command_line
       lea   di,param1
       call  parse_c
       jc    no_command_line
       lea   di,param2
       call  parse_c
       jc    no_command_line
       lea   di,param3
       call  parse_c
       jc    no_command_line
       lea   di,param4
       call  parse_c
       jc    no_command_line
       lea   di,param5
       call  parse_c
       jc    no_command_line
       lea   di,param6
       call  parse_c
no_command_line:
       mov   ax,0
       stosw
       ret
parse_c:
       lodsb
       cmp   al,13
       je   exit_parse_c
       cmp   al,20h
       loope parse_c
       je   exit_parse_2
       stosb
pc_1:
      lodsb
       cmp   al,13
       je   exit_parse_c
       cmp   al,20h
       je  exit_parse_2
       stosb
       loop pc_1
exit_parse_c:
       stc
       ret
exit_parse_2:
       clc
       ret
close_file:
       mov   bx,handle
       mov   ah,3eh
       int   21h
       ret
open_config:
       lea  dx,config_file
       mov  cx,0
       mov  al,0
       mov  ah,3dh
       int  21h
       jnc  good_open
       print errc1
       int  20h
good_open:
       mov  handle,ax
       ret
read_file:
       mov   bx,handle
       mov   cx,256
       lea   dx,fbuffer
       mov   ah,3fh
       int   21h
       ret
done_file:
       stc
       ret
next_buffer:
       call read_file
       jc   done_file
       mov  cx,ax
       cmp  ax,0
       je   done_file
       lea  si,fbuffer
       clc
       ret
fgetbyte1:
;
       cmp  replace_num,0
       je   no_replace
       call get_replace
       cmp  al,0
       je   no_replace1
       clc
       ret
no_replace1:
       mov  replace_num,0
       mov  replace_si,0
no_replace:
       cmp  cx,0
       jg   fgb0
       call next_buffer
       jnc  fgb0
       ret
fgb0:
       lodsb
       dec  cx
       clc
       ret
fgetbyte:
       call fgetbyte1
       jnc  fgb1
       ret
fgb1:
       cmp  al,1ah
       je   done_file
       cmp  al,10   ; line feeds are filtered out
       je   fgetbyte
       cmp  al,9    ; tabs are changed to spaces
       jne  no_tabs
       mov  al,20h
       clc
       ret
no_tabs:
       cmp  al,'a'
       jl   no_cap
       cmp  al,'z'
       jg   no_cap
       sub  al,32
no_cap:
       cmp  al,';'  ;comment character
       jne  no_comment
;
; run the line to a cr_lf
is_comment:
;
       call fgetbyte1
       jnc  fgb2
       ret
fgb2:
       cmp  al,13
       jne  is_comment
       ret  ; with a 13
;
no_comment:
; upper case, must check for replacement parms
       cmp   al,'%'  ; macro character
       je    do_replace
leave_replace:
       clc
       ret
do_replace:
       call fgetbyte1
       jnc  fgb3
       ret
fgb3:
       mov   replace_num,0
       mov   replace_si,0
       cmp  al,'1'
       jl   leave_replace
       cmp  al,'6'
       jg   leave_replace
       mov  replace_num,al
       mov  bl,al
       mov  bh,0
       and  bx,0fh
       push cx
       mov  cl,5
       dec  bx
       shl  bx,cl
       pop  cx
       lea  ax,param1[bx]
       mov  replace_si,ax
       jmp  fgetbyte
       ret
get_replace:
       push  si
       mov  si,replace_si
       cld
       lodsb
       mov  replace_si,si
       pop  si
       ret
; this is executed if we are getting info from the
dw_config  endp
