color1 equ 7fh
color2 equ 070h
color3 equ 17h
color4 equ 70h
color5 equ 71h
s0  db '  &File  &Edit  &Style  &Graph  &Print  &Database  &Tools  &Options  &Windows',0
s1       db  'A01:',0
s2       db  'READY',0
s3       db  '        A        B        C        D    '
         db  '    E        F        G        H',0
vidseg   dw  0
c123x     db  0
c123y     db  0
nine     db  9
ten      db  10
eighty     db  80
keyin      db 48
key        dw 4f4fh
return     dw 0f4f4h
color      db 030h
curr_curs  dw 0
public  color
kbuffl   dw 0
kbuff    db  80 dup(0)

showfake:
public showfake
; have to internally get modes
        mov   vidseg,0b800h
        mov   ah,15
        int   10h
        cmp   al,7
        jne   is_ctext
        mov   vidseg,0b000h
is_ctext:
        push  es
        mov   es,vidseg
; set up the screen colors
        mov   di,0
        mov   cx,80
        mov   ah,color1
        mov   al,20h
        cld
        rep   stosw
        mov   ah,color3
       mov    al,20h
        mov   cx,80*24
        rep   stosw
        mov   di,0
        mov   si,offset s0
        mov   bx,0
        call  printatt
        mov   di,160
        mov   si,offset s1
        mov   bx,0
        call  printatt
        mov   di,160-(2*5)
        mov   si,offset s2
        call  printatt
        mov   di,160*2
        mov   ah,color5
        mov   al,20h
        mov   cx,80
rep     stosw
        mov   di,160*2
        mov   si,offset s3
        call  printatt
        mov   di,3*160
        mov   bx,1
        mov   cx,20
        cld
; this puts the numbers on the side
disploop:
        push  cx
        push  di
        mov   cx,4
        mov   ah,color2
        mov   al,20h
        cld
rep     stosw
        pop   di
        mov   ah,bl
        mov   al,20h
        cmp   bl,10
        jl    lt_ten
        sub   ah,10
        mov   al,31h
        cmp   bl,20
        jl    lt_ten
        sub   ah,10
        mov   al,32h
lt_ten:
        mov   byte ptr es:[di]+6,':'
        or   ah,30h
        mov   byte ptr es:[di]+2,al
        or   ah,30h
        mov   byte ptr es:[di]+4,ah
        inc  bx
        add  di,160
        pop  cx
        loop disploop
;
; this is the cursor movement loop
;
bigcurs:
; print the current cell number
        mov al,c123x
        add  al,41h
        mov  s1,al
        mov  ah,0
        mov  al,c123y
        inc  al
        mov  ah,0
        div  ten
        or   ax,3030h
        mov  word ptr s1+1,ax
        mov  si,offset s1
        mov  di,160
        call  printatt
; print the cursor
; this makes a cursor 9 bytes wide
        mov di,8+(80*3*2) ; top cursor location
        mov al,c123x
        mul nine
        shl ax,1
        add di,ax
        mov al,c123y
        mov  cx,160
        mov  ah,0
        mul  cx
        add  di,ax
        mov cx,9
        mov si,160 +  8  ; where data goes
        mov curr_curs,di

loop123:
; locate the cursor at current byte
; di points to the cursor
        mov   al,byte ptr es:[di]
        mov   byte ptr es:[si],al
        mov   byte ptr es:[di]+1,color4
        add   di,2
        add   si,2
        loop loop123
; wait for keyboard input
waitkey:
; relocate at the current cursor location
        mov  dx,0104h
        add  dx,kbuffl
        mov  ah,2
        mov  bh,0
        int  10h
        mov  ah,0
        int  16h
        push ax
; now undo the big cursor
        mov cx,9
        mov si,160 +  10 ; where data goes
        mov di,curr_curs
undo_block:
        mov   byte ptr es:[di]+1,color3
        add   di,2
        loop  undo_block
        pop  ax
        cmp  ah,1
        jne  noesc
        jmp  restore
noesc:
; check for keypad stuff
        cmp  ah,47h
        jl   noend
        cmp  ah,51h
        jg   noend
        mov  bl,ah
        sub  bl,47h
        mov  bh,0
        shl  bx,1
        jmp  cs:kkey[bx]
noend:
        cmp  al,8
        jne  noback
; got a backspace
        cmp  kbuffl,0
        jne  fixk
        jmp  bigcurs
fixk:
        dec  kbuffl
        jmp  bigcurs
noback:
; we have a character
        cmp  al,13
        jne  dobuff
        cmp  al,0
        jne  nozero
        jmp  bigcurs
nozero:
        jmp  do13
dobuff:
        inc  kbuffl
        mov  bx,kbuffl
        mov  kbuff[bx]-1,al
        shl  bx,1
        add  bx,160+6
        mov  byte ptr es:[bx],al
        jmp  waitkey
do13:
        cmp  kbuffl,0
        jne  action
        jmp  bigcurs
action:
; put in last cursor location
        mov di,curr_curs
        mov  cx,kbuffl
        mov  kbuffl,0
        lea si,kbuff
doline:
        lodsb
        mov   byte ptr es:[di],al
        add   di,2
        loop  doline
        jmp  bigcurs
up:
pgup:
; up key was hit
        cmp  c123y,0
        jg   upz
        mov  c123y,20
upz:
        sub  c123y,1
        jmp  do13
left:
; left key was pressed
        cmp  c123x,0
        jg   leftz
        mov  c123x,8
leftz:
        sub  c123x,1
        jmp  do13
right:
; right cursor pressed
        cmp  c123x,7
        jl   rightz
        mov  c123x,0
        jmp  do13
rightz:
        add  c123x,1
        jmp  do13
down:
pgdn:
; down key pressed
        cmp  c123y,19
        jl   downz
        mov  c123y,0
        jmp   do13
downz:
        add  c123y,1
        jmp  do13
home:
        mov  c123y,0
        mov  c123x,0
        jmp  do13
endk:
        mov  c123y,19
        mov  c123x,7
        jmp  do13
kkey  dw  home,up,pgup,noend
      dw  left,noend,right,noend
      dw  endk,down,pgdn
; restore the screen
restore:
        pop  es
        push cs
        pop  ds
        push es
        pop  ds
        ret
printatt:
        cld
        lodsb
        cmp   al,0
        je    endprint
        cmp   al,'&'
        jne   no_amp
        mov   ah,color1
        and   ah,0f0h
        or    ah,04h
        lodsb
        stosw
        jmp   printatt
no_amp:
        stosb
        add   di,1
        jmp   printatt
endprint:
         ret
