; abracadabraabracadabra
;
; this is a test of a new compression
cseg segment 'CODE'
	assume cs:cseg,ds:cseg
	org	100h
worksize	equ 320
buffersize equ 4096-worksize-worksize
entry: jmp start
err1	db 07,'Command line error',13,10,'$'
err2	db 07,'Error opening file',13,10,'$'
err3	db 07,'Error Creating file',13,10,'$'
err4	db 07,'Unrecoverable read error',13,10,'$'
err5	db 07,'Write error (disk full?)',13,10,'$'
crlf	db 13,10,'$'
infile	db	65 dup(0)
handlei dw	0
outfile	db	65 dup(0)
handleo dw	0
atablemax	equ	8192
atablea	dw atablemax/2 dup(0)
atables	dw atablemax/2 dup(0)
wtablesize dw 0
atablesize dw 0
obuffsize dw 0
do_error:
	mov	ah,9
	int	21h
	int	20h
start:
	call	parse
	jc	do_error
	call	open_in
	jc	do_error
	call	create_file
	jc	do_error
	call	compress
; carry set indicates done
	int	20h
compress:
	mov	wtablesize,0	; size of work table
	mov	atablesize,0	; size of address table
	mov	obuffsize,0
	mov	si,offset ibuffer
compress_top:
	mov	ah,14
	mov	al,'.'
	int	10h
	call	fill_buffer
	jc	 done_compress
	cmp	cx,0
	jle	done_compress
;	do compress processes the ibuffer untill it is empty
	call	do_compress
	jc	 done_compress
; force the reader to write its buffer
; must flush all buffers each time through
        mov      cx,obuffsize
	jmp	compress_top
done_compress:
	cmp	atablesize,0
	je	 exit_compress
	call	write_file
exit_compress:
	clc
	ret
;
;	this is the loop for compressing the buffer
;
do_compress:
	lodsw
	mov	bx,word ptr ds:[si]
	dec	si
	call	proc_string
	jc	done_do_compress
	cmp	cx,0
	jle	done_do_compress
	loop	do_compress
	clc
done_do_compress:
	ret
;
ff	dw 0ffffh
write_ff:
	 lea	dx,ff
	 mov	cx,2
	 mov	bx,handleo
	 mov	ah,40h
	 int	21h
	 ret
; the ff symbol forces the unsqueezer to write its buffers
;
scan_string:
	push	cx
	push	si
	mov	bp,0	; length of longest guy
	cld
	mov	cx,obuffsize
        add     cx,worksize
	lea	di,wtable2
nextw:
repne scasb
	jne	store_string
	cmp	cx,2
	jle	store_string
	cmp	byte ptr es:[di],ah
	jne	nextw
	cmp	byte ptr es:[di+1],bl
	jne	nextw
; here we have a long string
; find out how long the string is
	push	cx
	push	di
;
	dec	di
	inc	cx
	inc	cx
	cmp	cx,256
	jle	lo_256
	mov	cx,256
lo_256:
	push	bx
	push	si
	dec	si
	mov	bx,di
repe	cmpsb
	pop	si
	sub	bx,di
	neg	bx
	dec	bx
	cmp	bx,bp
	jle	no_new
	mov	bp,bx
	mov	dx,di
no_new:
	pop	bx
	pop	di
	pop	cx
	cmp	bp,256
	jl	 nextw
store_string:
	pop	si
	pop	cx
        ret
;
proc_string:
;
; ax has the first word of string, bx has the second word
;
        call    scan_string
	cmp	bp,4
	jle	not_anywhere
; have a string length bp at offset dx
; cx is correct for the next byte, si is pointing to the next byte
	mov	di,atablesize
	add	obuffsize,bp
	sub	dx,bp
	dec	dx
	sub	dx,offset wtable
	mov	atables[di],bp
	mov	atablea[di],dx
	add	atablesize,2
; have passed some strings
	add	si,bp ; bypass string
        dec     si
        inc     cx
	sub	cx,bp
	jmp	comp_loop_e
not_anywhere:
; the string is a new one
; al has the character
	mov	di,wtablesize
	mov	dx,di
	add	di,offset wtable
	mov	bp,1
	inc	wtablesize
; now update the atable
	cld
	stosb
	mov	di,atablesize
	cmp	di,0
	je	store_a
	mov	ax,atablea[di-2]	; offset
	add	ax,atables[di-2]	; size
	cmp	ax,dx	; is it the last address + 1
	jne	store_a
	sub	di,2
	add	bp,atables[di]
	mov	dx,atablea[di]
	sub	atablesize,2
store_a:
	add	atablesize,2
	inc	obuffsize
	mov	atables[di],bp
	mov	atablea[di],dx
; have passed some strings
comp_loop_e:
	cmp	wtablesize,worksize
	jge	clear
	cmp	atablesize,atablemax
	jge	clear
comp_loopx:
	clc
	ret
clear:
	push	cx
	push	si
	call	write_file
	pop	si
	pop	cx
	jc	end_comp
	clc
	ret
; done with this stuff
;
end_comp:
	stc
	ret
fill_buffer:
        cmp     atablesize,0
        je      no_ff
        cmp     obuffsize,0
        jle     no_ff
	call	write_file
	call	write_ff
no_ff:
	mov	dx,offset ibuffer
	mov	cx,buffersize
	mov	bx,handlei
	mov	ah,3fh
	int	21h
	jc	 read_error
	cmp	ax,0
	je	 read_error
; set up for return
	mov	cx,ax
	lea	si,ibuffer
	mov	obuffsize,0
	clc
	ret
read_error:
	mov	cx,0
	stc
	ret
;
;
write_file:
	lea	di,obuffer
	mov	ax,wtablesize	; size of work table < 256
	stosw
	mov	cx,ax
	cmp	cx,0
	jle	move_w
	lea	si,wtable
	cld
rep	movsb
move_w:
	mov	ax,atablesize
	shr	ax,1
	stosw
	mov	cx,ax
	push	cx
	cmp	cx,0
	jle	write_tab
	lea	si,atables
	cld
a_loop1:
	lodsw
	dec	ax
	stosb
	loop	a_loop1
	lea	si,atablea
	mov	dx,0
	pop	 cx
a_loop2:
	lodsw
	test	dx,1
	jnz	a_store
	shl	ax,1
	shl	ax,1
	shl	ax,1
	shl	ax,1
	xchg	al,ah
	stosw
	jmp	aloope
a_store:
	or	 byte ptr ds:[di-1],ah
	stosb
aloope:
	inc	dx
	loop	a_loop2
by_old:
write_tab:
	mov	cx,di
	lea	dx,obuffer
	sub	cx,dx
	mov	bx,handleo
	mov	ah,40h
	int	21h
	jnc	good_write
bad_write:
	lea	dx,err5
	stc
	ret
good_write:
	cmp	ax,cx
	jne	bad_write
        mov     cx,wtablesize
        lea     si,wtable
        lea     di,wtable2
rep     stosb
	mov	atablesize,0
	mov	wtablesize,0
	clc
	ret


create_file:
	lea	dx,outfile
	mov	ax,3c00h
	mov	cx,0
	int	21h
	jc	open_errorc
	mov	handleo,ax
	clc
	ret
open_errorc:
	lea	dx,err3
	stc
	ret
open_in:
	lea	dx,infile
	mov	ax,3d10h
	int	21h
	jc	open_error
	mov	handlei,ax
	clc
	ret
open_error:
	lea	dx,err2
	stc
	ret
wtable	db worksize dup(0)
wtable2	db worksize dup(0)
ibuffer	equ this byte
obuffer	equ ibuffer+buffersize
parse:
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	mov	si,81h
	lea	di,infile
p1:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_error
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p1
	cmp	al,9
	je	p1
p2:
	stosb
	lodsb
	dec	cx
	cmp	cx,0
	jl	p3
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p3
	cmp	al,9
	jne	p2
p3:
	mov	al,0
	stosb
	lea	di,outfile
p4:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_error
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p4
	cmp	al,9
	je	p4
p5:
	stosb
	lodsb
	dec	cx
	cmp	cx,0
	jl	p6
	cmp	al,13
	je	p6
	cmp	al,20h
	je	p6
	cmp	al,9
	jne	p5
p6:
	mov	al,0
	stosb
	clc
	ret
p_error:
	lea	dx,err1
	stc
	ret
cseg ends
	end entry
