; abracadabraabracadabra
;
; this is a test of a new compression
cseg segment 'CODE'
	assume cs:cseg,ds:cseg
	org	100h
worksize   equ 256
buffersize equ 4096-worksize
entry: jmp start
err1	db 07,'Command line error',13,10,'$'
err2	db 07,'Error opening file',13,10,'$'
err3	db 07,'Error Creating file',13,10,'$'
err4	db 07,'Unrecoverable read error',13,10,'$'
err5	db 07,'Write error (disk full?)',13,10,'$'
crlf	db 13,10,'$'
infile	db	65 dup(0)
handlei dw	0
outfile	db	65 dup(0)
handleo dw	0
atablemax  equ  4094
atablea	dw atablemax dup(0)
atables	dw atablemax dup(0)
wtablesize dw 0
atablesize dw 0
obuffsize dw 0
do_error:
	mov	ah,9
	int	21h
	int	20h
start:
	call	parse
	jc	do_error
	call	open_in
	jc	do_error
	call	create_file
	jc	do_error
	call	compress
; carry set indicates done
	int	20h
compress:
        call    clean_buff
        mov     obuffsize,0
        lea     di,ibuffer
compress_top:
        mov     ah,14
        mov     al,'.'
        int     10h
int 3
        call    fill_buffer
        jc      done_compress
        cmp     cx,0
        je      done_compress
        mov     cx,atablesize
        cmp     cx,0
        jle     done_compress
;  do compress processes the ibuffer untill it is empty
        mov     si,0
        mov     bx,0
        call    do_uncompress
        jc      done_compress
; have used the old buffer, need the
        jmp     compress_top
done_compress:
        cmp      obuffsize,0
        je       exit_compress
        call      write_file
exit_compress:
        clc
        ret
;
;  this is the loop for compressing the buffer
;
do_uncompress:
        push   cx
        push   si
        mov    cx,atables[si]
        mov    si,atablea[si]
        add    si,offset wtable
do_move:
        add    obuffsize,cx
        cld
rep     movsb
        pop    si
        inc    si
        inc    si
        pop    cx
        loop   do_uncompress
        clc
        ret
bad_write:
        stc
        ret
write_file:
; now write out the file
        lea    dx,ibuffer
        mov    cx,obuffsize
        cmp    cx,0
        jle    by_write
        mov    bx,handleo
        mov    ah,40h
        int    21h
        jc     bad_write
        cmp    ax,cx
        jne    bad_write
by_write:
        mov    obuffsize,0
        lea     di,ibuffer
        clc
        ret
;
;
;
eof:
       pop    di
       clc
       mov   cx,0
       ret
read_errora:
        pop    di
        mov     cx,0
        stc
        ret
fill_buffer:
; get the size of the wtable
        push    di
        lea     dx,wtablesize
        mov     cx,2
	mov	bx,handlei
	mov	ah,3fh
	int	21h
        jc      read_errora
        cmp     ax,0
        je      eof
        cmp     ax,2
        jne     read_errora
        mov     cx,wtablesize
        cmp     cx,0ffffh
        jne     not_ff
        pop     di
        call    write_file
        jmp     fill_buffer
not_ff:
        cmp     cx,0
        je      get_atable
        mov     cx,wtablesize
        lea     dx,wtable
	mov	bx,handlei
	mov	ah,3fh
	int	21h
        jc      read_errora
        cmp     ax,cx
        jne     read_errora
get_atable:
        lea     dx,atablesize
        mov     cx,2
	mov	bx,handlei
	mov	ah,3fh
	int	21h
        jc      read_errora
        mov     cx,atablesize
        cmp     cx,0
        je      eof
        lea     dx,ibuffer
	mov	bx,handlei
	mov	ah,3fh
	int	21h
        jc      read_error
        cmp     ax,cx
        jne     read_error
; we have read atables into the ibuffer
        lea     si,ibuffer
        lea     di,atables
        mov     cx,ax
        cld
atable1:
        lodsb
        inc   ax
        stosw
        loop  atable1
; now work on the atable ; atable is 1.5 times the length
        mov     cx,atablesize
        mov     ax,cx
        inc     ax
        shr     ax,1
        add     cx,ax
        lea     dx,ibuffer
	mov	bx,handlei
	mov	ah,3fh
	int	21h
        jc      read_error
        cmp     ax,cx
        jne     read_error
; now undo the bit shifting stuff
        lea    si,ibuffer
        lea     di,atablea
        mov     dx,0
        mov     cx,atablesize
untable:
        test   dx,1
        jnz    unword
; here on a word boundary
        lodsw
        xchg   al,ah
        shr    ax,1
        shr    ax,1
        shr    ax,1
        shr    ax,1
        jmp    unstore
unword:
; here on an odd boundary
        mov    ah,byte ptr ds:[si-1]
        lodsb
        and    ah,0fh
unstore:
        stosw
        inc    dx
        loop   untable
;
; all done
        mov    cx,atablesize
        pop    di
        clc
        ret
read_error:
        pop     di
        mov     cx,0
        stc
        ret
clean_buff:
	lea	di,wtable
	mov	cx,worksize/2
        mov     ax,0
rep	stosw
        ret
;
;


create_file:
	lea	dx,outfile
	mov	ax,3c00h
	mov	cx,0
	int	21h
	jc	open_errorc
	mov	handleo,ax
	clc
	ret
open_errorc:
	lea	dx,err3
	stc
	ret
open_in:
	lea	dx,infile
	mov	ax,3d10h
	int	21h
	jc	open_error
	mov	handlei,ax
	clc
	ret
open_error:
	lea	dx,err2
	stc
	ret
wtable	equ this byte
ibuffer	equ wtable+worksize
obuffer	equ ibuffer+buffersize
parse:
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	mov	si,81h
	lea	di,infile
p1:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_error
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p1
	cmp	al,9
	je	p1
p2:
	stosb
	lodsb
	dec	cx
	cmp	cx,0
	jl	p3
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p3
	cmp	al,9
	jne	p2
p3:
	mov	al,0
	stosb
	lea	di,outfile
p4:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_error
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p4
	cmp	al,9
	je	p4
p5:
	stosb
	lodsb
	dec	cx
	cmp	cx,0
	jl	p6
	cmp	al,13
	je	p6
	cmp	al,20h
	je	p6
	cmp	al,9
	jne	p5
p6:
	mov	al,0
	stosb
	clc
	ret
p_error:
	lea	dx,err1
	stc
	ret
cseg ends
	end entry
