climit equ 510
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10
out_string db 30 dup(20h),13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
nodespace dw 0
buffloc  dw 0
buffsize dw 0
out_bytes dw 0
out_loc  dw 0
out_buff db 4096 dup(0)
last_node dw 0
free   dw 0
; prev points to previous guy in chain
; next points to next guy in rank list
; use next to find matching rank and prev to find characters
nodes  struc
  prev   dw ?
  next   dw ?
  who    dw ?
  rank   dw ?
nodes    ends
;
;
un_string:
; bx points to a guy who must be written out
     push  ax
     push  bx
     push  cx
     push  dx
     push  si
     push  di
     lea   di,out_buff+4095  ; last byte of outbuff
     mov   cx,0  ; count of how many to write
us_1:
     mov   ax,es:[bx].who
     mov   byte ptr ds:[di],al
     dec   di
     inc   cx
     mov   bx,es:[bx].prev
     cmp   bx,-1
     jne   us_1
     mov   si,di
    mov   di,out_bytes
    push  es
    mov   es,buffero
    cld
rep movsb
    pop   es
    mov   out_bytes,di
;
    pop   di
    pop   ax
    cmp   out_bytes,4000h
    jge   clear_buff
    clc
    ret
clear_buff:
    call  write_file
    ret
;
     pop   di
     pop   si
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     ret
;
snake:
;
; this is the routine that reads the file and calculates the snake
; the rank is then output in dx
;
    mov   last_node,0
    call  init_nodes
    call get_byte
    jnc  sn_00
    ret
sn_00:
    cmp   ax,climit+1
    je    snake
; ax has a word in it from the file
; start trace
sn_001:
    mov   bx,ax
    shl   bx,1
    shl   bx,1
    shl   bx,1
; first time through there is no base character
    cmp   last_node,0
    je    sn_4
    mov   si,last_node
    mov   last_node,0
    mov   bp,es:[bx].who
    mov   es:[si].who,bp
sn_4:
    call  un_string
; now bx has the base character
    call  get_byte  ; now trace through until we find this rank
    jnc   sn_01
    call  un_string
    ret
sn_01:
    cmp   ax,climit+1
    jne   sn_02
    call  init_nodes
    jmp   sn_001
sn_02:
    cmp   es:[bx].rank,ax
    jne   trace_next
    jmp   got_rank
trace_next:
; got a hit
    cmp   es:[bx].next,-1
    je    add_new_node
; here we have a hit and have to follow it
    mov   bx,es:[bx].next
    jmp   sn_01
add_new_node:
; we did not have a hit on this character, it must be added and then it
; is tha base for the next hit
    call  get_free
    mov   es:[bx].next,si
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[si].who,ax
    mov   es:[si].rank,cx
    mov   es:[si].prev,bx
    mov   last_node,0
    jmp   sn_001
;
;
got_rank:
; got a hit on rank
; have to trace it back
; have a hit, the who here hits last node
    call  un_string
; have to add the next node
    mov   di,bx
    call  get_free
; trace to last .next
gr_0:
    mov   dx,es:[di].rank
    cmp   es:[di].next,-1
    je    gr_1
    mov   di,es:[di].next
    jmp   gr_0
gr_1:
    mov   es:[di].next,si
    inc   dx
    mov   es:[si].rank,dx
    mov   es:[si].next,-1
    mov   es:[si].prev,bx
; now have to start all over again, di points to an unfilled who
    mov   last_node,di
;
; bx's who is the last known guy, ax has a node to add to bx, low
    mov   bx,es:[bx].who
    shl   bx,1
    shl   bx,1
    shl   bx,1
;
    jmp   sn_01
;
;
get_free:
; returns with a free node in si
    push  bx
    mov   bx,free
    cmp   bx,-1
    je    no_free
    mov   si,es:[bx].next
    mov   free,si
no_free:
    mov   si,bx
    pop   bx
    ret
;
;
largest  dw 0
    bits dw 9
    bitw dw 512
out_count dw 0,0
;



get_byte:
; gets a byte from the input stream into ax
   push si
   mov  si,buffloc
   push ds
   mov  ds,bufferi
   cld
   lodsw
   mov  ah,0
   pop  ds
   mov  buffloc,si
   cmp  si,buffsize
   pop  si
   jae  fill_buff
   clc
   ret
fill_buff:
   call  read_file
    ret
init_nodes:
    push  ax
    push  cx
    push  di
; set upt the free space
    mov   free,0
    mov   bits,9
    mov   bitw,512
    mov   cx,256
    mov   di,0
    mov   ax,0
in_0:
    mov   es:[di].next,-1
    mov   es:[di].prev,-1
    mov   es:[di].rank,ax
    mov   es:[di].who,ax
    inc   ax
    add   di,8
    loop  in_0
    mov   cx,4095
    mov   ax,di
in_1:
    add   ax,8
    mov   es:[di].next,ax
    mov   di,ax
    loop  in_1
    mov   es:[di].next,-1
    pop   di
    pop   cx
    pop   ax
    ret
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  read_file
    jc    error_exit
    push  es
    mov   es,nodespace
    call  init_nodes
    call  snake
    pop   es
good_exit:
    cmp  out_bytes,0
    je    ge_1
    call  write_file
ge_1:
    call  stats
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   cx,out_bytes
    mov   out_bytes,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    lea dx,error5
    stc
    ret
good_write:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret
;
stats:
    lea   di,out_string
    mov   ax,out_count
    mov   dx,out_count+2
    add   ax,8
    adc   dx,0
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    inc  di
    mov   ax,largest
    inc   ax
    shr   ax,1
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,03000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    lea dx,error3
    stc
    ret
good_read:
    cmp   ax,0
    je    bad_read
    mov   buffsize,ax
    mov   buffloc,0
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,100h ; 256*16 = 4096
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,4094
    push bx
; allocade nodespace
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:nodespace,ax
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
