;
passthru = 1  ; 1 is true which means MASM will create the passthroug
print macro string
    lea dx,string
    mov  ah,9
    int  21h
    endm
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
int20      dd  0
int20ip   equ word ptr int20
int20cs   equ word ptr int20 + 2
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
int27      dd  0
int27ip   equ word ptr int27
int27cs   equ word ptr int27 + 2
level0    db  00100000b   ; write access denied while we read
level1    db  00010000b   ; exclusive use
security  db  01000000b
semaphore db  -1
whandle   dw  0
; passthough only stuff
if passthru
stack   dw   256  dup(0)
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
savesp2  dw  0
savess2  dw  0
;
; this data is used by the passthru program only
;
mess1    db  13,10,'NET-WK1 Network Worksheet share service complete',13,10,'$'
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
START        PROC        far
dos:
; we are entering here due to a key being struck
; first check the dos area to see if the CTRL and ALT are ppasssed
;
; first call the dos interrupt so that it can handle the
; dos call we are interested in 2 calls, open and read
;
; these are semaphore items
        cmp    ah,0    ; exit
        je     check_kill
        cmp    ah,31h  ; exit
        je     check_kill
        cmp    ah,4ch  ; exit
        je     check_kill
        cmp    ah,4bh  ; exec
        je     check_exec
;
; the folowing are open/close items
;
        cmp    cs:semaphore,0
        jne    leave_21
        cmp    ah,3dh  ; open
        je     check_open
        cmp    ah,3eh  ; close
        je     check_close
        cmp    ah,3ch  ; create
        je     check_create
leave_21:
        jmp    cs:int21
check_close:
        jmp    proc_close
check_create:
        jmp    proc_create
check_kill:
        jmp    proc_kill
check_exec:
        jmp    proc_exec
;
check_open:
; test for the various file types
        call  check_ext
        jnc   open_wk1
; opening a file which is not our concern use the "any read mode"
        and   al,10001111b
        or    al,cs:level0  ; none wks security
        jmp   leave_21
open_wk1:
; here we have a wk1 to open
        cmp   cs:whandle,0
        je    open_it
; close first
        push  ax
        push  bx
        mov   bx,cs:whandle
        mov   cs:whandle,ax
        mov   ah,3eh
        pushf
        call  cs:int21
        pop   bx
        pop   ax
        mov   cs:whandle,0
;  issue the open
        and    al,10001111b
        or     al,cs:level1
        pushf
        call cs:int21
        jnc   good_old_open
;  open failed
        ret   2
good_old_open:
        mov   cs:whandle,ax
        clc
        ret  2
open_it:
; call the open
        and    al,10001111b
        or     al,cs:level1
        pushf
        call cs:int21
        jnc   good_old_open
        ret   2
proc_close:
        cmp   cs:whandle,0
        je    not_close
        cmp   cs:whandle,bx
        jne   not_close
; here we are asked to close a worksheet we opened - no way
        clc
        ret   2
not_close:
        jmp   cs:int21
proc_kill:
; here we are exiting the program, we must decrement the semaphore
        dec   cs:semaphore
        jmp   cs:int21
proc_exec:
; this is executing a new program
        push  bp
        mov   bp,dx
        mov   dl,cs:semaphore
        push  dx
        mov   dx,bp
;   bp and semaphore are in the stack
        call  check_123  ; check for executing 123.exe
        jc    non_123
        mov   cs:semaphore,0
        jmp   is_123
non_123:
       mov   cs:semaphore,-1
is_123:
; have to save the way out
        push  cs:savesp2
        push  cs:savess2
        mov   cs:savess2,ss
        mov   cs:savesp2,sp
        pushf
        call  cs:int21
        jc    failed_123
        mov   ss,cs:savess2
        mov   sp,cs:savesp2
        pop   dx
        mov   cs:savess2,dx
        pop   dx
        mov   cs:savesp2,dx
        pop   dx
        mov   cs:semaphore,dl
        pop   bp
        clc
        ret  2
failed_123:
        mov   ss,cs:savess2
        mov   sp,cs:savesp2
        pop   dx
        mov   cs:savess2,dx
        pop   dx
        mov   cs:savesp2,dx
        pop   dx
        mov   cs:semaphore,dl
        pop   bp
        stc
        ret  2
;
proc_create:
; create is a problem, it must be the same as an open input
; test for the various file types
        call  check_ext
        jnc   create_wk1
        pushf
        call  cs:int21
        jc    bad_non_wk1
; here we had a good create
        push  bx
; creating a file which is not our concern use the "any read mode"
        mov   bl,cs:level0
        call  re_create  ; closes and then opens i/o
        pop   bx
        ret   2    ; carry status returned from re_create
bad_non_wk1:
        stc
        ret  2
create_wk1:
; here we have a wk1 to create
        cmp   cs:whandle,0
        je    create_it
; close the old handle before we move on
        push  ax
; this closes the current handle before trying to create a new one
        push  bx
        mov   bx,cs:whandle
        mov   ah,3eh
        pushf
        call  cs:int21
        pop   bx
        pop   ax
        mov   cs:whandle,0
create_it:
; now issue a create to make sure it can be done
        pushf
        call cs:int21
        jnc   cclose_it
;  create failed
        ret   2
cclose_it:
        push  bx
        mov   bl,cs:level1
        call  re_create  ; closes and then opens i/o
        pop   bx
        jnc   good_rcreate
        mov   cs:whandle,0
        stc
        ret  2
good_rcreate:
        mov   cs:whandle,ax
        clc
        ret  2
dos27:
; this does the interrupt 27 accounting
        dec   cs:semaphore
        jmp   cs:int27
;
dos20:
        dec   cs:semaphore
        jmp   cs:int20
START        ENDP
services proc near
; this does services for routines in start
re_create:
; there has been a successful create with the handle in ax and
; the open type in bl, its time to close the guy and then
; re open i/o with the right mode
      push  bx
      mov   bx,ax
      mov   ax,3e00h  ; close
      pushf
      call  cs:int21
; now open it
      pop   bx
      mov   ax,3d02h  ; open i/o
      or    al,bl
      pushf
      call  cs:int21
      ret
check_ext:
; this looks at a file pointed to by ds:dx and
; determins if it is a WK? file
       push  ax
       push  cx
       push  di
       push  es
       push  ds
       pop   es
       cld
       mov   al,0
       mov   cx,128
       mov   di,dx
repne  scasb
       sub  di,5
       cmp  word ptr es:[di],'W.'
       je   found_dotw
       cmp  word ptr es:[di],'w.'
       je   found_dotw
exit_check_ext:
       pop  es
       pop  di
       pop  cx
       pop  ax
       stc
       ret
found_dotw:
       cmp  byte ptr es:[di+2],"K"
       je   got_a_wk
       cmp  byte ptr es:[di+2],"k"
       je   got_a_wk
       jmp  exit_check_ext
got_a_wk:
       pop  es
       pop  di
       pop  cx
       pop  ax
       clc
       ret
check_123:
; this looks at a file pointed to by ds:dx and
; determins if it is 123.exe
       push  ax
       push  cx
       push  di
       push  es
       push  ds
       pop   es
       cld
       mov   al,0
       mov   cx,128
       mov   di,dx
repne  scasb
       sub  di,5
       cmp  word ptr es:[di],'E.'
       je   found_dote
       cmp  word ptr es:[di],'e.'
       je   found_dote
exit_check_123:
       pop  es
       pop  di
       pop  cx
       pop  ax
       stc
       ret
found_dote:
       cmp  word ptr es:[di+2],"EX"
       je   got_a_exe
       cmp  word ptr es:[di+2],"ex"
       je   got_a_exe
       cmp  word ptr es:[di+2],"Ex"
       je   got_a_exe
       cmp  word ptr es:[di+2],"eX"
       je   got_a_exe
       jmp  exit_check_123
got_a_exe:
; check for 123
       sub  di,3
       cmp  word ptr es:[di],"21"
       jne  exit_check_123
       cmp  byte ptr es:[di+2],"3"
       jne  exit_check_123
       pop  es
       pop  di
       pop  cx
       pop  ax
       clc
       ret
services endp
setpass  proc  near
; set up a local stack
    if passthru
        lea  sp,stack+510
    endif
        print mess0
; first scan the line for slashes
        mov  cl,byte ptr ds:[80h]
        mov  ch,0
        cmp  cx,1
        jge  parse0
if passthru
bad_parse:
    print err1
    int   20h
else
    jmp  done_parse
endif
parse0:
    cld
    mov  si,81h
parse1:
   lodsb
   cmp   al,20h
   je    parse2
   cmp   al,13
   je    parse3
   cmp   al,'/'
   je    parse4
   jmp   parse5
parse2:
   loop  parse1
parse3:
   if   passthru
     jmp  bad_parse
   else
      jmp  done_parse
   endif
parse4:
   lodsb
   dec   cx
   mov   bl,01000000b  ; full access
   cmp   al,'1'   ; lowest
   je    switch1
   mov   bl,00100000b  ; write access denied
   cmp   al,'2'   ; lowest
   je    switch1
   mov   bl,00110000b  ; read access denied
   cmp   al,'3'   ; lowest
   je    switch1
   mov   bl,00010000b  ; read and write access denied
   cmp   al,'4'   ; lowest
   je    switch1
   jmp   bad_parse
switch1:
   mov   level0,bl
   cmp   cx,0
   je    parse3
   jmp   parse2
parse5:
   if  passthru
; here we have to save the current state of the parse in si
      dec   si
      inc   cx
      push  cx  ;remaining bytes in command line
      push  si
   endif
;
done_parse:
;
; redirect interrupts here
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dos
        int   21h
;
        push  es
        mov   ax,3520h
        int   21h
        mov   int20cs,es
        mov   int20ip,bx
        pop   es
        mov   ah,25h
        mov   al,20h
        lea   dx,dos20
        int   21h
;
        push  es
        mov   ax,3527h
        int   21h
        mov   int27cs,es
        mov   int27ip,bx
        pop   es
        mov   ah,25h
        mov   al,27h
        lea   dx,dos27
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
;  mov   si,81h
;  mov   cl,byte ptr ds:[80h]
;  mov   ch,0
   pop   si
   pop   cx   ; from the parse if the switches
   push  cx
   cmp   cx,0
   jle   no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   print   mess1
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int20
        mov   ah,25h
        mov   al,20h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int27
        mov   ah,25h
        mov   al,27h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
mess0    db  'NET-WK1 version 1.00',13,10
         db  'Copyright 1988 by Keith P. Graham',13,10,10
         db  'Registration is NOT optional!',13,10
         db  'Continued use of this product without registration',13,10
         db  'is in violation of Federal Law.',13,10,10
         db  'NET-WK1 Network Worksheet share service installing....',13,10,10
         db  '$'
if  passthru
err1     db  13,10,'When executing NET-WK1.COM the NET-WK1 command must be followed with',13,10
         db  'a valid DOS command. ',13,10,10,'$'
endif
CSEG        ENDS
        END        ENTPT
