print macro string
     lea  dx,string
     mov  ah,9
     int  21h
     endm
get  macro string
     lea  dx,string
     mov  ah,0ah
     int  21h
     endm
cSEG        SEGMENT PARA PUBLIC 'CODE'
        assume cs:cseg,ds:cseg,es:cseg
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTER:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
go16sw    db  0
interupt8 dd  0
intip8    equ word ptr interupt8
intcs8    equ word ptr interupt8 + 2
clock_cx  dw  0
clock_dx  dw  0
interupt16 dd  0
intip16    equ word ptr interupt16
intcs16    equ word ptr interupt16 + 2
clock_count db 0   ; check only every eighteen ticks
string_len dw 0 ; length of string to go to int 16
string_index dw  0
START        PROC        NEAR
int16:
; here we fake a keyboard
 ; let keyboard do its thing
        sti
        cmp  cs:go16sw,0
        jne  got_kb
jmp_back:
        jmp  cs:[interupt16]
got_kb:
        cmp  ah,1
        jg   jmp_back
        push bx
        mov  bx,cs:string_index
        cmp  ah,1
        je   check_kbd_only
        add  cs:string_index,2
        sub  cs:string_len,1
check_kbd_only:
        mov  ax,word ptr cs:string_area[bx]
        cmp  cs:string_len,0
        jg   return_string
        mov  cs:go16sw,0
return_string:
; set zero flag 0
        mov  bx,0
        cmp  bx,1
        pop  bx
        clc
        db   0cah,02,00  ; ret far 2
;
; here is the clock interrupt
;
clock:
; we are entering here due the clock being ticked
        pushf
 ; let clock do its thing
        call cs:[interupt8]
        sti
        inc  cs:clock_count
        cmp  cs:clock_count,9
        jg   got_clock
        iret
got_clock:
        cmp  cs:go16sw,1
        jne  go_on_clock
        iret
go_on_clock:
        mov  cs:clock_count,0
        push  ax
        push  bx
        push  cx
        push  dx
        mov   ah,00h
        int   1ah
; the registers are set as follows:
   ;cx is high order clock count
   ;dx is low order clock count
        and  dx,0fff0h
        cmp  cs:clock_cx,cx
        jne  go_back
        cmp  cs:clock_dx,dx
        jne  go_back
        jmp  gotcha
go_back:
;return to wherever
        pop   dx
        pop   cx
        pop   bx
        pop   ax
        iret
gotcha:
        mov  cs:go16sw,1
        mov  ah,14
        mov  al,7
        int  10h
        jmp  go_back
string_area dw 203  dup(0)
START        ENDP
setres  proc  near
        print   version
check_vers:
        mov  ah,30h
        int  21h
        cmp  al,2
        jge  check_command
        print   mess3
        int  20h
check_command:
; here we check for command line parameters
        cmp byte ptr ds:[80h],7
        jle  gettime1
        mov  time+1,0
        mov  cl,byte ptr ds:[80h]
        mov  ch,0
        mov  si,81h
        lea  di,time+2
com_space_scan:
        cld
        lodsb
        cmp al,13
        je  gettime1
        cmp al,' '
        je  com_space_scan_end
        jmp com_move_time
com_space_scan_end:
        loop com_space_scan
        jmp gettime1
com_move_time:
 ; got a non space byte
       cmp  al,'0'
       jl  gettime1
       cmp  al,'9'
       jg  gettime1
       stosb
       inc time+1
       lodsb
       cmp  al,' '
       je  com_move_command
       loop com_move_time
       jmp  gettime1
com_move_command:
       lea di,string_area
com_m_com_loop:
       lodsb
       mov ah,0
       stosw
       inc  string_len
       loop com_m_com_loop
; we have done a command line instead of an input
       jmp   got_time_com
gettime:
        print mess2
gettime1:
; get the time of the wakeup
        print mess1
        get time
got_time_com:
        cmp  time+1,6
        jne  gettime
        mov  cx,6
        lea  si,time+2
        cld
ctime_loop:
        lodsb
        cmp   al,'0'
        jl    gettime
        cmp   al,'9'
        jg    gettime
        loop  ctime_loop
; convert each word to binary
        mov   cx,3
        lea   si,time+2
        mov   di,si
        cld
ctime_loop2:
        push  cx
        lodsw
        and   ax,0f0fh
        mov   bl,ah
        mov   ah,0
        mov   cl,10
        mul   cl
        add   al,bl
        stosw
        pop   cx
        loop  ctime_loop2
; check each word for valid range
        mov   ax,word ptr time+6
        cmp   al,60
        jl    good_second
        jmp   gettime
good_second:
        mov   bx,ax
        mov   ax,word ptr time+4
        cmp   al,60
        jl    good_second2
        jmp   gettime
good_second2:
        mov   cl,60
        mul   cl
        add   bx,ax
        mov   ax,word ptr time+2
        cmp   al,24
        jl    good_second3
        jmp   gettime
good_second3:
        mov   cx,3600
        mov   dx,0
        mul   cx
        add   ax,bx
        jnc   seconds_nc
        inc   dx
seconds_nc:
; the number in dx:ax is the total number of seconds
; now must mul by 18.21 to get
; mov the dx to bx to save it for future use
        mov    bx,dx
        mov    si,ax
; si saves the low bytes of seconds
; clock ticks
        mov   clock_cx,0   ; cx is high
        mov   clock_dx,0   ; dx is low
; lets work on bx first
        mov   ax,bx
        mov   dx,0
        mov   cx,18
        mul   cx
        mov   clock_cx,ax
; thats the 18 part, now the .21 part must be dealt with
        mov   ax,bx
        mov   dx,0
        mov   cx,3383
        mul   cx
        mov   cx,16384
        div   cx
        add   clock_cx,ax
; dx has the remainder, the fractional part of the division
        mov   ax,dx
        mov   dx,0
        mov   cx,4
        mul   cx
        mov   clock_dx,ax
; now seconds hi are done
; work on seconds low
        mov   ax,si
        mov   dx,0
        mov   cx,18
        mul   cx
        add   clock_cx,dx
        add   clock_dx,ax
        jnc   clock_nc1
        inc   clock_cx
clock_nc1:
; now the fraction .206 which is about 3383/16384
        mov   ax,si
        mov   dx,0
        mov   cx,3383
        mul   cx
        mov   cx,16384
        div   cx
        add   clock_dx,ax
        jnc   clock_nc2
        inc   clock_cx
clock_nc2:
        and  clock_dx,0fff0h
; verify the clock is right
ask_ok:
        cmp   string_len,0
        jne   got_all_time
        print mess4
        get   yn_in
        cmp   yn,'Y'
        je    got_all_time
        cmp   yn,'y'
        je    got_all_time
        cmp   yn,'N'
        je    get_more_time
        cmp   yn,'n'
        je    get_more_time
        print crlf
        jmp   ask_ok
get_more_time:
        jmp   gettime
got_all_time:
; all done clock stuff
; get the string
        cmp   string_len,0
        je    no_string_yet
        jmp   got_all_string
no_string_yet:
        print mess5
        mov   pluscount,0
        mov   string_len,0
        lea   di,string_area
        mov   cx,200
char_loop:
        push  cx
        mov   ah,0
        int   16h
        cmp   ax,4e2bh
        jne   no_plus
        inc   pluscount
        cmp   pluscount,3
        je    got_plus
        jmp   by_plus
no_plus:
        mov   pluscount,0
by_plus:
        inc   string_len
        stosw
        mov   ah,14
        cmp   al,13
        jne   no13
        int   10h
        mov   al,10
        mov   ah,14
no13:
       int    10h
        loop  char_loop
; fell out of loop
        add   string_len,2
got_plus:
        sub   string_len,2
; finished entering string
;
; check it
ask_ok2:
        print mess6
        get yn_in
        cmp   yn,'Y'
        je    got_all_string
        cmp   yn,'y'
        je    got_all_string
        cmp   yn,'N'
        je    get_more_string
        cmp   yn,'n'
        je    get_more_string
        cmp   yn,'A'
        je    abort
        cmp   yn,'a'
        je    abort
        print crlf
        jmp   ask_ok2
abort:
        print crlf
        int  20h
get_more_string:
        jmp  no_string_yet
got_all_string:
 ;      mov the whole thing to 60h
        lea cx,setres
        sub cx,100h
        mov si,100h
        mov di,60h
        cld
rep     movsb
; set ds and es registers different
        push  cs
        pop   ax
        sub   ax,0ah
        mov   ds,ax
        mov   es,ax
; set the interrupt 8 to us
        mov   ax,3508h
        int   21h
        mov   intcs8,es
        mov   intip8,bx
        mov   ax,2508h
        lea   dx,clock
        int   21h
; set the interrupt 16 to us
        mov   ax,3516h
        int   21h
        mov   intcs16,es
        mov   intip16,bx
        mov   ax,2516h
        lea   dx,int16
        int   21h
        lea   dx,string_area
        add   dx,0fh
        add   dx,string_len
        add   dx,string_len
        mov   cl,4
        shr   dx,cl
        sub   dx,0ah
        mov   ah,31h
        mov   al,0
        int   21h
        int   20h
version db  'WAKEUP.COM Resident Wakeup call',13,10
        db  'Written by Keith P. Graham 9/19/86',13,10
        db  'For the users of PC Rockland BBS (914) 353-2176'
crlf   db   13,10,'$'
mess1   db  13,10,'Enter time for wakeup as HHMMSS (military time) :$'
mess2   db  13,10,'Time must be six numeric digits, try again',13,10,'$'
mess3   db  'Wrong DOS version, Must be 2.0 or later',13,10
mess4   db  13,10,'Is the time correct? (y/n): $'
mess5   db 13,10,'Enter Keystrokes to be entered ar the specified time.',13,10
        db  'You have up to 200 characters you can enter.',13,10
        db  'When you are done, press the + on the numeric keypad',13,10
        db  'three times.',13,10,10,'   ENTER:',13,10,'$'
mess6   db  13,10,'Is the sequence correct (Y)es, (N)o, (A)bort :$'
pluscount db 0
yn_in   db  2,0
yn      db  '  '
time    db  7,0,'        '
setres  endp
CSEG        ENDS
        END        enter
