;
print macro string
   lea  dx,string
   mov  ah,9
   int  21h
   endm
cseg segment para public 'CODE'
  assume cs:cseg,ds:cseg
  org  100h
entry: jmp main
hi   db 13,10,'AutoStrew BBS file Distrubution Utility',13,10
     db 'Copyright 1988 by Keith P. Graham',13,10,'$'
cfile   db 64 dup(0)
filein  db 64 dup(0)
fileb   db 64 dup(0)
fileout db 64 dup(0)
line    db 256 dup(0)
last_keep db 0
handlec dw 0
handlei dw 0
handleo dw 0
handlen dw 0
bcount  dw 0
lcount  dw 0
ccount  dw 0  ; count of how many lines of data to check
eof   db 26
e1  db  'Bad configuration file',13,10,'$'
e2  db  'Error reading config file',13,10,'$'
e3  db  'Syntax error in config file',13,10,'$'
e4  db  "Can't Rename Directory",13,10,'$'
e5  db  'Error Creating new directory file',13,10,'$'
e6  db  'Error opening Old directory for input',13,10,'$'
e7  db  'Error opening target directory',13,10,'$'
e8  db  "Can't find EOF of target directory",13,10,'$'
e9  db  'Error reading the old directory file',13,10,'$'
x1   db  16 dup(0)
x2   db  16 dup(0)
x3   db  16 dup(0)
x4   db  16 dup(0)
x5   db  16 dup(0)
x6   db  16 dup(0)
x7   db  16 dup(0)
x8   db  16 dup(0)
x9   db  16 dup(0)
x0   db  16 dup(0)
xa   db  16 dup(0)
xb   db  16 dup(0)
xc   db  16 dup(0)
xd   db  16 dup(0)
xe   db  16 dup(0)
xf   db  16 dup(0)
main:
   print hi
;  1) get the configuration file
   call  getconfig
;  2) process the config file
    call  procconfig
;  3) rename the input file to .BAK
    call  backup
;  4) create the new output file
    call   create_new
;  5) open the old BAK file for input
    call   open_old
;  6) open strew dir for appending
    call  open_append
;  7) prime pump, read up to 32k from the input file
    call  read_file
read_loop:
    cmp    bcount,2
    jle    close_files
;  8) get a line of data from the input file
    call   get_line
;  9) process a line
    call   proc_line
    jmp    read_loop
close_files:
; write out the eof's
   lea  dx,eof
   mov  cx,1
   mov  ah,40h
   mov  bx,handlen
   int   21h
   lea  dx,eof
   mov  cx,1
   mov  ah,40h
   mov  bx,handleo
   int   21h
   int 20h
;
; service routines
;
;
proc_line:
; this checks a line. If the carry is set them strew it
;  1) if the first byte is a space then the line is kept
    cmp   line,20h
    je    check_space
    cmp   line,13
    je    keep_line
    cmp   line,9
    je    keep_line
    cmp   line,8
    je    keep_line
; now we have to go through each of the upper case compares
; one at a time
    push   si
    lea    di,x0
    mov    cx,ccount  ; count of lines
cl1:
    push   di
    push   cx
    lea    si,line
    mov    cx,lcount
cl2:
    push   cx
    push   di
    push   si
    mov    cx,16
cl3:
; check each byte of the line
    cmp    byte ptr ds:[di],0
    je     cl9
    lodsb
    cmp    al,'a'
    jl     cl4
    sub    al,32
cl4:
    cmp    al,byte ptr ds:[di]
    jne    cl6
    inc    di
    loop   cl3
cl6:
    pop    si
    inc    si
    pop    di
    pop    cx
    loop   cl2
    pop    cx
    pop    di
    add    di,16
    loop   cl1
    pop    si
    jmp    keep_line
cl9:
    pop    si
    pop    di
    pop    cx
    pop    cx
    pop    di
    pop    si
; move the line
    mov    last_keep,1
move_line:
    mov   bx,handleo
    mov   cx,lcount
    lea   dx,line
    mov   ah,40h
    int   21h
    ret
check_space:
    cmp   last_keep,0
    je    keep_line
    cmp   line[31],'|'
    je    move_line
keep_line:
; here the line is keep so we write it out to the new file
    mov    last_keep,0
    mov   bx,handlen
    mov   cx,lcount
    lea   dx,line
    mov   ah,40h
    int   21h
    clc
    ret
get_line:
; copies a line into the line buffer for work
     lea  di,line
     mov  cx,0
gl1:
     lodsb
     stosb
     inc  cx
     cmp  al,10
     je   end_line
     cmp  al,26
     je   end_line1
     jmp  gl1
end_line1:
     sub   bcount,cx
     dec   cx
     mov   lcount,cx
     ret
end_line:
     sub   bcount,cx
     mov   lcount,cx
     cmp   bcount,200h
     jl    get_more_buffer
     ret
get_more_buffer:
; move down the buffer thats left
     lea   di,buffer
     mov   cx,bcount
     cld
rep   movsb
     lea    si,buffer
     mov    dx,di
     mov    cx,7fffh
     sub    cx,bcount
     mov    ah,3fh
     mov   bx,handlei
     int   21h
     jc    bad_read
     add   bcount,ax
     ret
read_file:
; reads up to 32k from the input file
     lea   dx,buffer
     mov   cx,7fffh
     mov   ah,3fh
     mov   bx,handlei
     int   21h
     jc    bad_read
     cmp   ax,0
     je    bad_read
     mov   bcount,ax
     lea   si,buffer
     ret
bad_read:
     print e9
     int  20h
open_append:
; this open the out file for append
; int 3
    lea   dx,fileout
    mov   ax,3d02h
    int   21h
    jc    bad_a
    mov   handleo,ax
; seek to the end
    mov   bx,ax
    mov   ax,4202h
    mov   cx,-1
    mov   dx,-20
    int   21h
    jc   bad_a
; now loop looking for a 26
    mov   cx,23
oa1:
    push  cx
    lea   dx,fileout
    mov   cx,1
    mov   ah,3fh
    mov   bx,handleo
    int   21h
    pop   cx
    jc    bad_a
    cmp   al,1
    jne   open_old
    cmp   fileout,26
    je    got_a
    loop  oa1
bad_a:
     print  e7
     int  20h
bad_a2:
     print  e8
     int  20h
got_a:
; seek backwards one
    mov   ax,4201h
    mov   bx,handleo
    mov   cx,-1
    mov   dx,-1
    int   21h
    jc   bad_a
open_old:
    lea   dx,fileb
    mov   ax,3d00h
    mov   cx,0
    int   21h
    jc    bad_old
    mov   handlei,ax
    ret
bad_old:
    print  e6
    int   20h
create_new:
; creates the new dir file
    lea   dx,filein
    mov   ax,3c00h
    mov   cx,0
    int   21h
    jc    bad_cn
    mov   handlen,ax
    ret
bad_cn:
    print  e5
    int   20h
backup:
; renames the input file to the output file for security
   lea   si,filein
   lea   di,fileb
b1:
   lodsb
   cmp    al,0
   je     b2
   cmp    al,'.'
   je     b2
   stosb
   jmp   b1
b2:
   mov   ax,'B.'
   stosw
   mov   ax,'KA'
   stosw
   mov   ax,0
   stosw
; do the rename
   lea   dx,filein
   lea   di,fileb
   mov   ah,56h
   int   21h
   jc    bad_ren
   ret
bad_ren:
   print  e4
   int   20h
procconfig:
; first get the input dir
    lea   di,filein
    lea   si,buffer
pc1:
    lodsb
    cmp   al,13
    je  pc1
    cmp   al,10
    je  pc1
    cmp  al,20h
    je   pc1
    cmp  al,26
    je   bad_pc
pc2:
    stosb
    lodsb
    cmp   al,20h
    je    pc3
    cmp   al,13
    je    pc3
    cmp   al,10
    je    pc3
    cmp  al,26
    je   bad_pc
    jmp   pc2
pc3:
    lea   di,fileout
pc4:
    lodsb
    cmp   al,13
    je  pc4
    cmp   al,10
    je  pc4
    cmp  al,20h
    je   pc4
    cmp  al,26
    je   bad_pc
pc5:
    stosb
    lodsb
    cmp   al,20h
    je    pc6
    cmp   al,13
    je    pc6
    cmp   al,10
    je    pc6
    cmp  al,26
    je   bad_pc
    jmp   pc5
bad_pc:
    print  e3
    int  20h
pc6:
; have the two files, now the check data
    lea   di,x0
    mov   cx,16
pc7:
    push  di
pc8:
    lodsb
    cmp   al,13
    je  pc8
    cmp   al,10
    je  pc8
    cmp  al,20h
    je   pc8
    cmp  al,26
    je   end_pc
pc9:
; convert to upper case
    cmp   al,'a'
    jl    do_store
    sub   al,32
do_store:
    stosb
    lodsb
    cmp   al,20h
    je    pc0
    cmp   al,13
    je    pc0
    cmp   al,10
    je    pc0
    cmp  al,26
    je   end_pc
    jmp   pc9
pc0:
    pop   di
    add   di,16
    inc   ccount
    loop  pc7
    push  cx
end_pc:
    pop    cx
    ret
getconfig:
   lea  di,cfile
   mov  si,81h
m1:
   lodsb
   cmp  al,20h
   je   m1
   cmp  al,13
   jne  m2
badc:
   print e1
   int  20h
m2:
   stosb
   lodsb
   cmp   al,20h
   je  m3
  cmp   al,13
   jne  m2
m3:
   lea  dx,cfile
   mov  ah,3dh
   mov  al,0
   mov  cx,0
   int  21h
   jc   badc
   mov  handlec,ax
   lea  dx,buffer
   mov  cx,8000h
   mov  bx,handlec
   mov  ah,3fh
   int  21h
   jc   badc2
   cmp  ax,0
   je   badc2
   mov  bx,handlec
   mov  ah,3eh
   int  21h
   ret
badc2:
   print e2
   int  20h
buffer  equ this byte
cseg  ends
    end entry
