; makes trees
cseg segment 'CODE'
   assume cs:cseg,ds:cseg
   org  100h
enter: jmp start
; data
disks     dw 27 dup(0)
istack    dw 256 dup(0)
work_dir  db 70 dup(0)
buffer    dw 0
curr_dir  dw 0
disk1 db 'C'
disk2 db 'C'
dirs  dw 1024 dup(0)
dircount  dw 0
crlf   db 13,10,'$'
start:
; strategy is to get a tree for each disk on list, starting with C:
; 64K will provide enough tree space for 1000 subdirectories if each
; is 64 bytes long
     mov   sp,offset istack+254
     call   shrink
     call   setup
     call   get_tree
     call   sort_dirs
     call   print_dirs
     int   20h
print_dirs:
;
     lea   dx,crlf
     mov   ah,9
     int   21h
;
     lea   si,dirs
     mov   cx,dircount
pd0:
     push  cx
     push  ds
     push  es
;
     lodsw
     mov  di,ax
     mov  dx,ax
     mov  es,buffer
     mov  cx,64
     mov  al,0
repne scasb
     sub  di,dx
     mov  cx,di
     mov  ds,buffer
     mov  bx,1
     mov  ah,40h
     int  21h
;
;
     pop   es
     pop   ds
     lea   dx,crlf
     mov   ah,9
     int   21h
;
     pop   cx
     loop  pd0
     ret
setup:
; sets up disk stuff
     lea  di,dirs
     mov   ax,0
     mov    cx,1024
su1:
     stosw
     add  ax,64
     loop  su1
     ret
sort_dirs:
; does a bubble sort on the directory info
     mov  cx,dircount
     dec  cx
     cmp  cx,0
     jg   pass1
     ret
pass1:
     push  cx
     lea  bx,dirs
     mov  bp,0
pass2:
     push  cx
     mov   si,word ptr ds:[bx]
     inc   bx
     inc   bx
     mov   di,word ptr ds:[bx]
     push  ds
     push  es
     push  si
     push  di
     mov   es,buffer
     mov   ds,buffer
     mov   cx,64
repe cmpsb
     pop   di
     pop   si
     pop   es
     pop   ds
     jl    pass3
     mov   word ptr ds:[bx],si
     mov   word ptr ds:[bx-2],di
     inc   bp
pass3:
     pop   cx
     loop  pass2
     pop   cx
     cmp   bp,0
     loopne  pass1
     ret
get_tree:
     mov   si,0  ; starting directory
     mov   di,64 ; where the first found dir goes
get_top:
; this is the top of the tree getting routine
     push  si  ; save for bottom of loop
     push  di
     push  ds
     mov   ds,buffer
     mov   cx,64
     lea   di,work_dir
     cld
rep   movsb
     pop  ds
     cmp   work_dir,0
     jne   next_tree
     pop   di
     pop   si
     ret
next_tree:
; find the end of the tree
     lea   di,work_dir
     mov   al,0
nt1:
     scasb
     jne   nt1
     dec   di
     mov   ax,'.*'
     stosw
     mov   ah,0
     stosw
; get files with dir stuff in them
;
; get the first file
      lea   dx,work_dir
      mov   ah,4eh
      mov   cx,48
      int   21h
      jnc   gf1
; no matches, we have to get the next working di
      jmp   bot_loop
gf1:
; test for a directory
      mov   al,byte ptr ds:[95h]
      and   al,16
      cmp   al,16
      jne   gf2
      cmp   byte ptr ds:[9eh],'.'
      je    gf2
; have a hit on a dir, must be added to list
     pop   di
     pop   si
     push  si
     push  di
;
     mov   ax,buffer
     push  es
     push  ds
     mov   ds,ax
     mov   es,ax
     cld
move_loop:
     lodsb
     cmp  al,0
     je   ml2
     stosb
     jmp   move_loop
ml2:
     pop   ds
     mov   si,9eh
ml3:
     lodsb
     cmp   al,0
     je    ml4
     stosb
     jmp   ml3
ml4:
     mov  al,'\'
     mov  ah,0
     stosw
     pop   es
     pop   di
     add   di,64
     inc   dircount
     push  di
;
gf2:
      mov   ah,4fh
      int   21h
      jnc   gf1
;
bot_loop:
     pop   di
     pop   si
     add   si,64
     jmp   get_top
;
;
;
shrink:
     lea   bx,last_byte
     mov   cl,4
     add   bx,15
     shr   bx,cl
     mov   ah,4ah
     int   21h
; don't even care if there is not enough memory
     mov   ah,48h
     mov   bx,1000h
     int   21h
     jnc   good_mem
     int  20h
good_mem:
     mov   buffer,ax
; clean out memory
     push  es
     mov   es,ax
     mov   ax,0
     mov   di,ax
     mov   cx,8000h
     cld
rep  stosw
; initialize the root directory
     mov   di,ax
     mov   al,disk1
     mov   ah,':'
     stosw
     mov   ah,0
     mov   al,'\'
     stosw
     pop   es
     mov   dircount,1
     ret
last_byte equ this byte
cseg ends
     end enter
